/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Curl.xs. Do not edit this file, edit Curl.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Curl.xs"
/* vim: ts=4:sw=4:fdm=marker

 *
 * Perl interface for libcurl. Check out the file README for more info.
 */

/*
 * Copyright (C) 2000, 2001, 2002, 2005, 2008 Daniel Stenberg, Cris Bailiff, et al.
 * Copyright (C) 2011-2015 Przemyslaw Iskra.
 * You may opt to use, copy, modify, merge, publish, distribute and/or
 * sell copies of the Software, and permit persons to whom the
 * Software is furnished to do so, under the terms of the MPL or
 * the MIT/X-derivate licenses. You may pick one of these licenses.
 */
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"

/* Implement perl5 7169efc77525df for older perls (part 1): */
#define STMT_START  do
#define STMT_END    while (0)

#include "perl.h"
#include "XSUB.h"

/* Implement perl5 7169efc77525df for older perls (part 2): */
#undef STMT_START
#undef STMT_END
#define STMT_START  do
#define STMT_END    while (0)

#include <curl/curl.h>
#include <curl/easy.h>
#include <curl/multi.h>
#include "const-defenums-h.inc"

#ifndef LIBCURL_COPYRIGHT
# define LIBCURL_COPYRIGHT "1996 - 2013 Daniel Stenberg, <daniel@haxx.se>."
#endif

#ifndef LIBCURL_TIMESTAMP
# define LIBCURL_TIMESTAMP "DEV"
#endif

#ifndef Newx
# define Newx(v,n,t)	New(0,v,n,t)
# define Newxc(v,n,t,c)	Newc(0,v,n,t,c)
# define Newxz(v,n,t)	Newz(0,v,n,t)
#endif

#ifndef hv_stores
# define hv_stores(hv,key,val) hv_store( hv, key, sizeof( key ) - 1, val, 0 )
#endif
#ifndef hv_fetchs
# define hv_fetchs(hv,key,store) hv_fetch( hv, key, sizeof( key ) - 1, store );
#endif

#ifndef CLEAR_ERRSV
# define CLEAR_ERRSV()					\
	STMT_START {						\
		sv_setpvn( ERRSV, "", 0 );		\
		if ( SvMAGICAL( ERRSV ) )		\
			mg_free( ERRSV );			\
		SvPOK_only( ERRSV );			\
	} STMT_END
#endif

#ifndef croak_sv
# define croak_sv( arg )		\
	STMT_START {				\
		SvSetSV( ERRSV, arg );	\
		croak( NULL );			\
	} STMT_END
#endif

#define die_code( pkg, num )			\
	STMT_START {						\
		SV *errsv = sv_newmortal();		\
		sv_setref_iv( errsv, "Net::Curl::" pkg "::Code", num ); \
		croak_sv( errsv );				\
	} STMT_END


#ifndef mPUSHs
# define mPUSHs( sv ) PUSHs( sv_2mortal( sv ) )
#endif
#ifndef mXPUSHs
# define mXPUSHs( sv ) XPUSHs( sv_2mortal( sv ) )
#endif
#ifndef PTR2nat
# define PTR2nat(p)	(PTRV)(p)
#endif

/*
 * Convenient way to copy SVs
 */
#define SvREPLACE( dst, src ) \
	STMT_START {						\
		SV *src_ = (src);				\
		if ( dst )						\
			sv_2mortal( dst );			\
		if ( (src_) && SvOK( src_ ) )	\
			dst = newSVsv( src_ );		\
		else							\
			dst = NULL;					\
	} STMT_END

/*
 * create a reference for perl callbacks
 */
#define SELF2PERL( obj ) \
	sv_bless( newRV_inc( (obj)->perl_self ), SvSTASH( (obj)->perl_self ) )

typedef struct {
	/* function that will be called */
	SV *func;

	/* user data */
	SV *data;
} callback_t;

typedef struct simplell_s simplell_t;
struct simplell_s {
	/* next in the linked list */
	simplell_t *next;

	/* curl option it belongs to */
	PTRV key;

	/* the actual data */
	void *value;
};

//----------------------------------------------------------------------

typedef enum {
	CB_MULTI_SOCKET = 0,
	CB_MULTI_TIMER,
	CB_MULTI_LAST,
} perl_curl_multi_callback_code_t;

struct perl_curl_multi_s {
	/* last seen version of this object */
	SV *perl_self;

	/* curl multi handle */
	CURLM *handle;

	/* list of callbacks */
	callback_t cb[ CB_MULTI_LAST ];

	/* list of data assigned to sockets */
	/* key: socket fd; value: user sv */
	simplell_t *socket_data;

	/* list of easy handles attached to this multi */
	/* key: our easy pointer, value: easy SV */
	simplell_t *easies;
};

//----------------------------------------------------------------------

typedef struct perl_curl_easy_s perl_curl_easy_t;
typedef struct perl_curl_form_s perl_curl_form_t;
typedef struct perl_curl_share_s perl_curl_share_t;
typedef struct perl_curl_multi_s perl_curl_multi_t;

static struct curl_slist *
perl_curl_array2slist( pTHX_ struct curl_slist *slist, SV *arrayref )
{
	AV *array;
	int array_len, i;

	if ( !SvOK( arrayref ) || !SvROK( arrayref ) )
		croak( "not an array" );

	array = (AV *) SvRV( arrayref );
	array_len = av_len( array );

	for ( i = 0; i <= array_len; i++ ) {
		SV **sv;
		char *string;

		sv = av_fetch( array, i, 0 );
		if ( !SvOK( *sv ) )
			continue;
		string = SvPV_nolen( *sv );
		slist = curl_slist_append( slist, string );
	}

	return slist;
}

#if 0
static void *
perl_curl_simplell_get( pTHX_ simplell_t *start, PTRV key )
{
	simplell_t *now = start;

	if ( now == NULL )
		return NULL;

	while ( now ) {
		if ( now->key == key )
			return &(now->value);
		if ( now->key > key )
			return NULL;
		now = now->next;
	}

	return NULL;
}
#endif


static void *
perl_curl_simplell_add( pTHX_ simplell_t **start, PTRV key )
{
	simplell_t **now = start;
	simplell_t *tmp = NULL;

	while ( *now ) {
		if ( (*now)->key == key )
			return &( (*now)->value );
		if ( (*now)->key > key )
			break;
		now = &( (*now)->next );
	}

	tmp = *now;
	Newx( *now, 1, simplell_t );
	(*now)->next = tmp;
	(*now)->key = key;
	(*now)->value = NULL;

	return &( (*now)->value );
}

static void *
perl_curl_simplell_del( pTHX_ simplell_t **start, PTRV key )
{
	simplell_t **now = start;

	while ( *now ) {
		if ( (*now)->key == key ) {
			void *ret = (*now)->value;
			simplell_t *tmp = *now;
			*now = (*now)->next;
			Safefree( tmp );
			return ret;
		}
		if ( (*now)->key > key )
			return NULL;
		now = &( (*now)->next );
	}
	return NULL;
}

#define SIMPLELL_FREE( list, freefunc )			\
	STMT_START {								\
		if ( list ) {							\
			simplell_t *next, *now = list;		\
			do {								\
				next = now->next;				\
				freefunc( now->value );			\
				Safefree( now );				\
			} while ( ( now = next ) != NULL );	\
		}										\
	} STMT_END


/* generic function for our callback calling needs */
static IV
perl_curl_call( pTHX_ callback_t *cb, int argnum, SV **args )
{
	dSP;
	int i;
	IV status;
	SV *olderrsv = NULL;
	int method_call = 0;

	if ( ! cb->func || ! SvOK( cb->func ) ) {
		warn( "callback function is not set\n" );
		return -1;
	} else if ( SvROK( cb->func ) )
		method_call = 0;
	else if ( SvPOK( cb->func ) )
		method_call = 1;
	else {
		warn( "Don't know how to call the callback\n" );
		return -1;
	}

	ENTER;
	SAVETMPS;

	PUSHMARK( SP );

	EXTEND( SP, argnum );
	for ( i = 0; i < argnum; i++ )
		mPUSHs( args[ i ] );

	if ( cb->data )
		mXPUSHs( newSVsv( cb->data ) );

	PUTBACK;

	if ( SvTRUE( ERRSV ) )
		olderrsv = sv_2mortal( newSVsv( ERRSV ) );

	if ( method_call )
		call_method( SvPV_nolen( cb->func ), G_SCALAR | G_EVAL );
	else
		call_sv( cb->func, G_SCALAR | G_EVAL );

	SPAGAIN;

	if ( SvTRUE( ERRSV ) ) {
		/* cleanup after the error */
		(void) POPs;
		status = -1;
	} else {
		status = POPi;
	}

	if ( olderrsv )
		sv_setsv( ERRSV, olderrsv );

	PUTBACK;
	FREETMPS;
	LEAVE;

	return status;
}

#define PERL_CURL_CALL( cb, arg ) \
	perl_curl_call( aTHX_ (cb), sizeof( arg ) / sizeof( (arg)[0] ), (arg) )


static int
perl_curl_any_magic_nodup( pTHX_ MAGIC *mg, CLONE_PARAMS *param )
{
	warn( "Net::Curl::(Easy|Form|Multi) does not support cloning\n" );
	mg->mg_ptr = NULL;
	return 1;
}

static void *
perl_curl_getptr( pTHX_ SV *self, MGVTBL *vtbl )
{
	MAGIC *mg;

	if ( !self )
		return NULL;

	if ( !SvOK( self ) )
		return NULL;

	if ( !SvROK( self ) )
		return NULL;

	if ( !sv_isobject( self ) )
		return NULL;

	for ( mg = SvMAGIC( SvRV( self ) ); mg != NULL; mg = mg->mg_moremagic ) {
		if ( mg->mg_type == PERL_MAGIC_ext && mg->mg_virtual == vtbl )
			return mg->mg_ptr;
	}

	return NULL;
}


static void *
perl_curl_getptr_fatal( pTHX_ SV *self, MGVTBL *vtbl, const char *name,
		const char *type )
{
	void *ret;
	SV **perl_self;

	if ( ! sv_derived_from( self, type ) )
		croak( "'%s' is not a %s object", name, type );

	ret = perl_curl_getptr( aTHX_ self, vtbl );

	if ( ret == NULL )
		croak( "'%s' is an invalid %s object", name, type );

	/*
	 * keep alive: this trick makes sure user will not destroy last
	 * existing reference from inside of a callback.
	 */
	perl_self = ret;
	if ( perl_self && *perl_self )
		sv_2mortal( newRV_inc( *perl_self ) );

	return ret;
}


static void
perl_curl_setptr( pTHX_ SV *self, MGVTBL *vtbl, void *ptr )
{
	MAGIC *mg;

	if ( perl_curl_getptr( aTHX_ self, vtbl ) )
		croak( "object already has our pointer" );

	mg = sv_magicext( SvRV( self ), 0, PERL_MAGIC_ext,
		vtbl, (const char *) ptr, 0 );
	mg->mg_flags |= MGf_DUP;
}


/* code shamelessly stolen from ExtUtils::Constant */
static void
perl_curl_constant_add( pTHX_ HV *hash, const char *name, I32 namelen,
		SV *value )
{
#if PERL_REVISION == 5 && PERL_VERSION >= 9
	SV **sv = hv_fetch( hash, name, namelen, TRUE );
	if ( !sv )
		croak( "Could not add key '%s' to %%Net::Curl::", name );

	if ( SvOK( *sv ) || SvTYPE( *sv ) == SVt_PVGV ) {
		newCONSTSUB( hash, name, value );
	} else {
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-value"
		SvUPGRADE( *sv, SVt_RV );
#pragma clang diagnostic pop
		SvRV_set( *sv, value );
		SvROK_on( *sv );
		SvREADONLY_on( value );
	}
#else
	newCONSTSUB( hash, (char *)name, value );
#endif
}

struct iv_s {
	const char *name;
	I32 namelen;
	IV value;
};
#define IV_CONST( c ) \
	{ #c, sizeof( #c ) - 1, c }
struct pv_s {
	const char *name;
	I32 namelen;
	const char *value;
	I32 valuelen;
};
#define PV_CONST( c ) \
	{ #c, sizeof( #c ) - 1, c, sizeof( c ) - 1 }


typedef perl_curl_easy_t *Net__Curl__Easy;
typedef perl_curl_form_t *Net__Curl__Form;
typedef perl_curl_multi_t *Net__Curl__Multi;
typedef perl_curl_share_t *Net__Curl__Share;

/* default base object */
#define HASHREF_BY_DEFAULT		sv_2mortal( newRV_noinc( (SV *) newHV() ) )

#include "curl-Easy-c.inc"
#include "curl-Form-c.inc"
#include "curl-Multi-c.inc"
#include "curl-Share-c.inc"
#include "Curl_Easy_setopt.c"

#line 481 "Curl.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 625 "Curl.c"

/* INCLUDE:  Including 'const-curl-xs.inc' from 'Curl.xs' */


/* INCLUDE: Returning to 'Curl.xs' from 'const-curl-xs.inc' */


XS_EUPXS(XS_Net__Curl_getdate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl_getdate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timedate");
    {
	char *	timedate = (char *)SvPV_nolen(ST(0))
;
	time_t	RETVAL;
	dXSTARG;
#line 526 "Curl.xs"
		RETVAL = curl_getdate( timedate, NULL );
#line 646 "Curl.c"
	XSprePUSH;
	PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	char *	RETVAL;
	dXSTARG;
#line 533 "Curl.xs"
		RETVAL = curl_version();
#line 665 "Curl.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl_version_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl_version_info)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 541 "Curl.xs"
		const curl_version_info_data *vi;
		HV *ret;
#line 684 "Curl.c"
	SV *	RETVAL;
#line 544 "Curl.xs"
		/* {{{ */
		vi = curl_version_info( CURLVERSION_NOW );
		if ( vi == NULL )
			croak( "curl_version_info() returned NULL\n" );
		ret = newHV();

		(void) hv_stores( ret, "age", newSViv( vi->age ) );
		if ( vi->age >= CURLVERSION_FIRST ) {
			if ( vi->version )
				(void) hv_stores( ret, "version", newSVpv( vi->version, 0 ) );
			(void) hv_stores( ret, "version_num", newSVuv( vi->version_num ) );
			if ( vi->host )
				(void) hv_stores( ret, "host", newSVpv( vi->host, 0 ) );
			(void) hv_stores( ret, "features", newSViv( vi->features ) );
			if ( vi->ssl_version )
				(void) hv_stores( ret, "ssl_version", newSVpv( vi->ssl_version, 0 ) );
			(void) hv_stores( ret, "ssl_version_num", newSViv( vi->ssl_version_num ) );
			if ( vi->libz_version )
				(void) hv_stores( ret, "libz_version", newSVpv( vi->libz_version, 0 ) );
			if ( vi->protocols ) {
				const char * const *p = vi->protocols;
				AV *prot;
				prot = (AV *) sv_2mortal( (SV *) newAV() );
				while ( *p != NULL ) {
					av_push( prot, newSVpv( *p, 0 ) );
					p++;
				}

				(void) hv_stores( ret, "protocols", newRV( (SV*) prot ) );
			}
		}
		if ( vi->age >= CURLVERSION_SECOND ) {
			if ( vi->ares )
				(void) hv_stores( ret, "ares", newSVpv( vi->ares, 0 ) );
			(void) hv_stores( ret, "ares_num", newSViv( vi->ares_num ) );
		}
		if ( vi->age >= CURLVERSION_THIRD ) {
			if ( vi->libidn )
				(void) hv_stores( ret, "libidn", newSVpv( vi->libidn, 0 ) );
		}
#ifdef CURLVERSION_FOURTH
		if ( vi->age >= CURLVERSION_FOURTH ) {
			(void) hv_stores( ret, "iconv_ver_num", newSViv( vi->iconv_ver_num ) );
			if ( vi->libssh_version )
				(void) hv_stores( ret, "libssh_version", newSVpv( vi->libssh_version, 0 ) );
		}
#endif

		RETVAL = newRV( (SV *) ret );
		/* }}} */
#line 737 "Curl.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE:  Including 'curl-Easy-xs.inc' from 'Curl.xs' */


/* INCLUDE:  Including 'curl-Form-xs.inc' from 'curl-Easy-xs.inc' */


/* INCLUDE:  Including 'curl-Multi-xs.inc' from 'curl-Form-xs.inc' */


/* INCLUDE:  Including 'curl-Share-xs.inc' from 'curl-Multi-xs.inc' */


/* INCLUDE:  Including 'const-share-xs.inc' from 'curl-Share-xs.inc' */


/* INCLUDE: Returning to 'curl-Share-xs.inc' from 'const-share-xs.inc' */


XS_EUPXS(XS_Net__Curl__Share_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Share_new)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 2)
       croak_xs_usage(cv,  "sclass=\"Net::Curl::Share\", base=HASHREF_BY_DEFAULT");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	sclass;
	SV *	base;
#line 163 "./curl-Share-xs.inc"
		perl_curl_share_t *share;
		HV *stash;
#line 777 "Curl.c"

	if (items < 1)
	    sclass = "Net::Curl::Share";
	else {
	    sclass = (const char *)SvPV_nolen(ST(0))
;
	}

	if (items < 2)
	    base = HASHREF_BY_DEFAULT;
	else {
	    base = ST(1)
;
	}
#line 166 "./curl-Share-xs.inc"
		if ( ! SvOK( base ) || ! SvROK( base ) )
			croak( "object base must be a valid reference\n" );

		share = perl_curl_share_new( aTHX );
		perl_curl_setptr( aTHX_ base, &perl_curl_share_vtbl, share );

		stash = gv_stashpv( sclass, 0 );
		ST(0) = sv_bless( base, stash );

		share->perl_self = NULL;

		XSRETURN(1);
#line 805 "Curl.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__Curl__Share_setopt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Share_setopt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "share, option, value");
    {
	Net__Curl__Share	share = (Net__Curl__Share) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_share_vtbl,
		"share", "Net::Curl::Share" )
;
	int	option = (int)SvIV(ST(1))
;
	SV *	value = ST(2)
;
#line 186 "./curl-Share-xs.inc"
		CURLSHcode ret1 = CURLSHE_OK, ret2 = CURLSHE_OK;
#line 829 "Curl.c"
#line 188 "./curl-Share-xs.inc"
		switch ( option ) {
			case CURLSHOPT_LOCKFUNC:
			case CURLSHOPT_UNLOCKFUNC:
			case CURLSHOPT_USERDATA:
				croak( "Lockling is implemented internally" );
				break;
			case CURLSHOPT_SHARE:
			case CURLSHOPT_UNSHARE:
				ret1 = curl_share_setopt( share->handle,
					option, (long) SvIV( value ) );
				break;
			default:
				ret1 = CURLSHE_BAD_OPTION;
				break;
		};
		if ( ret1 != CURLSHE_OK || ( ret1 = ret2 ) != CURLSHE_OK )
			die_code( "Share", ret1 );
#line 848 "Curl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__Curl__Share_strerror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Share_strerror)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 211 "./curl-Share-xs.inc"
		const char *errstr;
#line 863 "Curl.c"
	SV *	RETVAL;
#line 213 "./curl-Share-xs.inc"
		if ( items < 1 || items > 2 )
			croak( "Usage: Net::Curl::Share::strerror( [share], errnum )" );
		errstr = curl_share_strerror( SvIV( ST( items - 1 ) ) );
		RETVAL = newSVpv( errstr, 0 );
#line 870 "Curl.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'curl-Multi-xs.inc' from 'curl-Share-xs.inc' */


/* INCLUDE:  Including 'const-multi-xs.inc' from 'curl-Multi-xs.inc' */


/* INCLUDE: Returning to 'curl-Multi-xs.inc' from 'const-multi-xs.inc' */


XS_EUPXS(XS_Net__Curl__Multi_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_new)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 2)
       croak_xs_usage(cv,  "sclass=\"Net::Curl::Multi\", base=HASHREF_BY_DEFAULT");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	sclass;
	SV *	base;
#line 184 "./curl-Multi-xs.inc"
		perl_curl_multi_t *multi;
		HV *stash;
#line 901 "Curl.c"

	if (items < 1)
	    sclass = "Net::Curl::Multi";
	else {
	    sclass = (const char *)SvPV_nolen(ST(0))
;
	}

	if (items < 2)
	    base = HASHREF_BY_DEFAULT;
	else {
	    base = ST(1)
;
	}
#line 187 "./curl-Multi-xs.inc"
		if ( ! SvOK( base ) || ! SvROK( base ) )
			croak( "object base must be a valid reference\n" );

		multi = perl_curl_multi_new();
		perl_curl_setptr( aTHX_ base, &perl_curl_multi_vtbl, multi );

		/* those must be set or else socket_action() segfaults */
		curl_multi_setopt( multi->handle, CURLMOPT_SOCKETFUNCTION,
			cb_multi_socket );
		curl_multi_setopt( multi->handle, CURLMOPT_SOCKETDATA, multi );

		stash = gv_stashpv( sclass, 0 );
		ST(0) = sv_bless( base, stash );

		multi->perl_self = SvRV( ST(0) );

		XSRETURN(1);
#line 934 "Curl.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__Curl__Multi_add_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_add_handle)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "multi, easy");
    {
	Net__Curl__Multi	multi = (Net__Curl__Multi) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_multi_vtbl,
		"multi", "Net::Curl::Multi" )
;
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(1),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
#line 211 "./curl-Multi-xs.inc"
		CURLMcode ret;
#line 958 "Curl.c"
#line 213 "./curl-Multi-xs.inc"
		if ( easy->multi )
			croak( "Specified easy handle is attached to %s multi handle already",
				easy->multi == multi ? "this" : "another" );

		ret = curl_multi_add_handle( multi->handle, easy->handle );
		if ( !ret ) {
			SV **easysv_ptr;
			easysv_ptr = perl_curl_simplell_add( aTHX_ &multi->easies,
				PTR2nat( easy ) );
			*easysv_ptr = SELF2PERL( easy );
			easy->multi = multi;
		}
		MULTI_DIE( ret );
#line 973 "Curl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__Curl__Multi_remove_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_remove_handle)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "multi, easy");
    {
	Net__Curl__Multi	multi = (Net__Curl__Multi) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_multi_vtbl,
		"multi", "Net::Curl::Multi" )
;
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(1),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
#line 232 "./curl-Multi-xs.inc"
		CURLMcode ret;
#line 996 "Curl.c"
#line 234 "./curl-Multi-xs.inc"
		CLEAR_ERRSV();
		if ( easy->multi != multi )
			croak( "Specified easy handle is not attached to %s multi handle",
				easy->multi ? "this" : "any" );

		ret = perl_curl_easy_remove_from_multi( aTHX_ easy );

		/* rethrow errors */
		if ( SvTRUE( ERRSV ) )
			croak( NULL );

		MULTI_DIE( ret );
#line 1010 "Curl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__Curl__Multi_info_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_info_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "multi");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Curl__Multi	multi = (Net__Curl__Multi) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_multi_vtbl,
		"multi", "Net::Curl::Multi" )
;
#line 252 "./curl-Multi-xs.inc"
		int queue;
		CURLMsg *msg;
#line 1032 "Curl.c"
#line 255 "./curl-Multi-xs.inc"
		CLEAR_ERRSV();
		while ( (msg = curl_multi_info_read( multi->handle, &queue ) ) ) {
			/* most likely CURLMSG_DONE */
			if ( msg->msg != CURLMSG_NONE && msg->msg != CURLMSG_LAST ) {
				Net__Curl__Easy easy;
				SV *errsv;

				curl_easy_getinfo( msg->easy_handle,
					CURLINFO_PRIVATE, (void *) &easy );

				EXTEND( SP, 3 );
				mPUSHs( newSViv( msg->msg ) );
				mPUSHs( SELF2PERL( easy ) );

				errsv = sv_newmortal();
				sv_setref_iv( errsv, "Net::Curl::Easy::Code",
					msg->data.result );
				PUSHs( errsv );

				/* cannot rethrow errors, because we want to make sure we
				 * return the easy, but $@ should be set */

				XSRETURN( 3 );
			}

			/* rethrow errors */
			if ( SvTRUE( ERRSV ) )
				croak( NULL );
		};

		/* rethrow errors */
		if ( SvTRUE( ERRSV ) )
			croak( NULL );

		XSRETURN_EMPTY;
#line 1069 "Curl.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__Curl__Multi_fdset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_fdset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "multi");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Curl__Multi	multi = (Net__Curl__Multi) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_multi_vtbl,
		"multi", "Net::Curl::Multi" )
;
#line 296 "./curl-Multi-xs.inc"
		CURLMcode ret;
		fd_set fdread, fdwrite, fdexcep;
		int maxfd, i;
		int readsize, writesize, excepsize;
		unsigned char readset[ sizeof( fd_set ) ] = { 0 };
		unsigned char writeset[ sizeof( fd_set ) ] = { 0 };
		unsigned char excepset[ sizeof( fd_set ) ] = { 0 };
#line 1097 "Curl.c"
#line 304 "./curl-Multi-xs.inc"
		FD_ZERO( &fdread );
		FD_ZERO( &fdwrite );
		FD_ZERO( &fdexcep );

		ret = curl_multi_fdset( multi->handle,
			&fdread, &fdwrite, &fdexcep, &maxfd );
		MULTI_DIE( ret );

		readsize = writesize = excepsize = 0;

		/* TODO: this is rather slow, should copy whole bytes instead, but
		 * some fdset implementations may be hard to predict */
		if ( maxfd != -1 ) {
			for ( i = 0; i <= maxfd; i++ ) {
				if ( FD_ISSET( i, &fdread ) ) {
					readsize = i / 8 + 1;
					readset[ i / 8 ] |= 1 << ( i % 8 );
				}
				if ( FD_ISSET( i, &fdwrite ) ) {
					writesize = i / 8 + 1;
					writeset[ i / 8 ] |= 1 << ( i % 8 );
				}
				if ( FD_ISSET( i, &fdexcep ) ) {
					excepsize = i / 8 + 1;
					excepset[ i / 8 ] |= 1 << ( i % 8 );
				}
			}
		}

		EXTEND( SP, 3 );
		mPUSHs( newSVpvn( (char *) readset, readsize ) );
		mPUSHs( newSVpvn( (char *) writeset, writesize ) );
		mPUSHs( newSVpvn( (char *) excepset, excepsize ) );
#line 1132 "Curl.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__Curl__Multi_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "multi");
    {
	Net__Curl__Multi	multi = (Net__Curl__Multi) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_multi_vtbl,
		"multi", "Net::Curl::Multi" )
;
#line 343 "./curl-Multi-xs.inc"
		long timeout;
		CURLMcode ret;
#line 1153 "Curl.c"
	long	RETVAL;
	dXSTARG;
#line 346 "./curl-Multi-xs.inc"
		ret = curl_multi_timeout( multi->handle, &timeout );
		MULTI_DIE( ret );

		RETVAL = timeout;
#line 1161 "Curl.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl__Multi_setopt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_setopt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "multi, option, value");
    {
	Net__Curl__Multi	multi = (Net__Curl__Multi) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_multi_vtbl,
		"multi", "Net::Curl::Multi" )
;
	int	option = (int)SvIV(ST(1))
;
	SV *	value = ST(2)
;
#line 359 "./curl-Multi-xs.inc"
		CURLMcode ret1 = CURLM_OK, ret2 = CURLM_OK;
#ifdef CURLMOPT_PIPELINING_SERVER_BL
#ifdef CURLMOPT_PIPELINING_SITE_BL
		char **blacklist;
#endif
#endif
#line 1191 "Curl.c"
#line 366 "./curl-Multi-xs.inc"
		switch ( option ) {
			case CURLMOPT_SOCKETDATA:
				SvREPLACE( multi->cb[ CB_MULTI_SOCKET ].data, value );
				break;

			case CURLMOPT_SOCKETFUNCTION:
				SvREPLACE( multi->cb[ CB_MULTI_SOCKET ].func, value );
				break;

			/* introduced in 7.16.0 */
#ifdef CURLMOPT_TIMERDATA
#ifdef CURLMOPT_TIMERFUNCTION
			case CURLMOPT_TIMERDATA:
				SvREPLACE( multi->cb[ CB_MULTI_TIMER ].data, value );
				break;

			case CURLMOPT_TIMERFUNCTION:
				SvREPLACE( multi->cb[ CB_MULTI_TIMER ].func, value );
				ret2 = curl_multi_setopt( multi->handle, CURLMOPT_TIMERFUNCTION,
					SvOK( value ) ? cb_multi_timer : NULL );
				ret1 = curl_multi_setopt( multi->handle, CURLMOPT_TIMERDATA, multi );
				break;
#endif
#endif

			/* introduced in 7.30.0 */
#ifdef CURLMOPT_PIPELINING_SERVER_BL
#ifdef CURLMOPT_PIPELINING_SITE_BL
			case CURLMOPT_PIPELINING_SERVER_BL:
			case CURLMOPT_PIPELINING_SITE_BL:
				blacklist = perl_curl_multi_blacklist( aTHX_ value );
				ret1 = curl_multi_setopt( multi->handle, option, blacklist );
				if ( blacklist )
					Safefree( blacklist );
				break;
#endif
#endif

			/* default cases */
			default:
				if ( option < CURLOPTTYPE_OBJECTPOINT ) {
					/* A long (integer) value */
					ret1 = curl_multi_setopt( multi->handle, option,
						(long) SvIV( value ) );
				} else {
					croak( "Unknown curl multi option" );
				}
				break;
		};
		MULTI_DIE( ret2 );
		MULTI_DIE( ret1 );
#line 1244 "Curl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__Curl__Multi_perform); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_perform)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "multi");
    {
	Net__Curl__Multi	multi = (Net__Curl__Multi) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_multi_vtbl,
		"multi", "Net::Curl::Multi" )
;
#line 423 "./curl-Multi-xs.inc"
		int remaining;
		CURLMcode ret;
#line 1264 "Curl.c"
	int	RETVAL;
	dXSTARG;
#line 426 "./curl-Multi-xs.inc"
		CLEAR_ERRSV();
		do {
			ret = curl_multi_perform( multi->handle, &remaining );
		} while ( ret == CURLM_CALL_MULTI_PERFORM );

		/* rethrow errors */
		if ( SvTRUE( ERRSV ) )
			croak( NULL );

		MULTI_DIE( ret );

		RETVAL = remaining;
#line 1280 "Curl.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if LIBCURL_VERSION_NUM >= 0x071C00
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Net__Curl__Multi_wait); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_wait)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "multi, ...");
    {
	Net__Curl__Multi	multi = (Net__Curl__Multi) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_multi_vtbl,
		"multi", "Net::Curl::Multi" )
;
#line 449 "./curl-Multi-xs.inc"
		int timeout = -1;
		SV *extra_fds = NULL;
		int remaining;
		CURLMcode ret;
		struct curl_waitfd *wait_for = NULL;
		unsigned int extra_nfds = 0;
#line 1309 "Curl.c"
	int	RETVAL;
	dXSTARG;
#line 456 "./curl-Multi-xs.inc"
		CLEAR_ERRSV();

		if ( items > 1 )
			timeout = SvIV( ST( items - 1 ) );
		if ( items > 2 )
			extra_fds = ST( 1 );

		if ( extra_fds && SvOK( extra_fds ) )
		{
			int i;
			AV *array;
			if ( !SvROK( extra_fds ) || SvTYPE( SvRV( extra_fds ) ) != SVt_PVAV )
				croak( "must be an arrayref" );
			array = (AV *) SvRV( extra_fds );
			extra_nfds = 1 + av_len( array );

			Newxz( wait_for, extra_nfds, struct curl_waitfd );

			for ( i = 0; i < extra_nfds; i++ )
			{
				HV *hash;
				SV **tmp, **sv;
				sv = av_fetch( array, i, 0 );
				if ( !SvOK( *sv ) )
					continue;
				if ( !SvROK( *sv ) || SvTYPE( SvRV( *sv ) ) != SVt_PVHV )
					croak( "must be a hashref" );
				hash = (HV *) SvRV( *sv );

				tmp = hv_fetchs( hash, "fd", 0 );
				if ( tmp && *tmp && SvOK( *tmp ) )
					wait_for[i].fd = SvIV( *tmp );

				tmp = hv_fetchs( hash, "events", 0 );
				if ( tmp && *tmp && SvOK( *tmp ) )
					wait_for[i].events = SvIV( *tmp );

				/* there is also revents which will be returned by curl */
				tmp = hv_fetchs( hash, "revents", 0 );
				if ( tmp && *tmp && SvOK( *tmp ) )
					wait_for[i].revents = SvIV( *tmp );
			}
		}

		ret = curl_multi_wait( multi->handle, wait_for, extra_nfds, timeout,
			&remaining );

		if ( wait_for )
		{
			int i;
			AV *array = (AV *) SvRV( extra_fds );
			for ( i = 0; i < extra_nfds; i++ )
			{
				HV *hash;
				SV **sv;
				short revents = wait_for[i].revents;
				sv = av_fetch( array, i, 0 );
				hash = (HV *) SvRV( *sv );

				(void) hv_stores( hash, "revents", newSViv( revents ) );
			}

			Safefree( wait_for );
		}

		/* rethrow errors */
		if ( SvTRUE( ERRSV ) )
			croak( NULL );

		MULTI_DIE( ret );

		RETVAL = remaining;
#line 1385 "Curl.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Net__Curl__Multi_socket_action); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_socket_action)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "multi, sockfd=CURL_SOCKET_BAD, ev_bitmask=0");
    {
	Net__Curl__Multi	multi = (Net__Curl__Multi) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_multi_vtbl,
		"multi", "Net::Curl::Multi" )
;
	int	sockfd;
	int	ev_bitmask;
#line 540 "./curl-Multi-xs.inc"
		int remaining;
		CURLMcode ret;
#line 1410 "Curl.c"
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    sockfd = CURL_SOCKET_BAD;
	else {
	    sockfd = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    ev_bitmask = 0;
	else {
	    ev_bitmask = (int)SvIV(ST(2))
;
	}
#line 543 "./curl-Multi-xs.inc"
		CLEAR_ERRSV();
		do {
#ifdef CURL_CSELECT_IN
			ret = curl_multi_socket_action( multi->handle,
				(curl_socket_t) sockfd, ev_bitmask, &remaining );
#else
			ret = curl_multi_socket( multi->handle,
				(curl_socket_t) sockfd, &remaining );
#endif
		} while ( ret == CURLM_CALL_MULTI_PERFORM );

		/* rethrow errors */
		if ( SvTRUE( ERRSV ) )
			croak( NULL );

		MULTI_DIE( ret );

		RETVAL = remaining;
#line 1446 "Curl.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if LIBCURL_VERSION_NUM >= 0x070f05
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Net__Curl__Multi_assign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_assign)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "multi, sockfd, value=NULL");
    {
	Net__Curl__Multi	multi = (Net__Curl__Multi) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_multi_vtbl,
		"multi", "Net::Curl::Multi" )
;
	unsigned long	sockfd = (unsigned long)SvUV(ST(1))
;
	SV *	value;
#line 573 "./curl-Multi-xs.inc"
		CURLMcode ret;
		void *sockptr;
#line 1474 "Curl.c"

	if (items < 3)
	    value = NULL;
	else {
	    value = ST(2)
;
	}
#line 576 "./curl-Multi-xs.inc"
		if ( value && SvOK( value ) ) {
			SV **valueptr;
			valueptr = perl_curl_simplell_add( aTHX_ &multi->socket_data,
				sockfd );
			if ( !valueptr )
				croak( "internal Net::Curl error" );
			if ( *valueptr )
				sv_2mortal( *valueptr );
			sockptr = *valueptr = newSVsv( value );
		} else {
			SV *oldvalue;
			oldvalue = perl_curl_simplell_del( aTHX_ &multi->socket_data, sockfd );
			if ( oldvalue )
				sv_2mortal( oldvalue );
			sockptr = NULL;
		}
		ret = curl_multi_assign( multi->handle, sockfd, sockptr );
		MULTI_DIE( ret );
#line 1501 "Curl.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__Curl__Multi_strerror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_strerror)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 602 "./curl-Multi-xs.inc"
		const char *errstr;
#line 1517 "Curl.c"
	SV *	RETVAL;
#line 604 "./curl-Multi-xs.inc"
		if ( items < 1 || items > 2 )
			croak( "Usage: Net::Curl::Multi::strerror( [multi], errnum )" );
		errstr = curl_multi_strerror( SvIV( ST( items - 1 ) ) );
		RETVAL = newSVpv( errstr, 0 );
#line 1524 "Curl.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl__Multi_handles); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_handles)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "multi");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Curl__Multi	multi = (Net__Curl__Multi) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_multi_vtbl,
		"multi", "Net::Curl::Multi" )
;
#line 619 "./curl-Multi-xs.inc"
			simplell_t *now;
#line 1547 "Curl.c"
#line 621 "./curl-Multi-xs.inc"
		if ( GIMME_V == G_VOID )
			XSRETURN( 0 );

		now = multi->easies;

		if ( GIMME_V == G_SCALAR ) {
			IV i = 0;
			while ( now ) {
				i++;
				now = now->next;
			}
			ST(0) = newSViv( i );
			XSRETURN( 1 );
		}
		while ( now ) {
			XPUSHs( newSVsv( now->value ) );
			now = now->next;
		}
#line 1567 "Curl.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__Curl__Multi_CLONE_SKIP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Multi_CLONE_SKIP)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	SV *	pkg = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 645 "./curl-Multi-xs.inc"
		(void ) pkg;
		RETVAL = 1;
#line 1588 "Curl.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'curl-Form-xs.inc' from 'curl-Multi-xs.inc' */


/* INCLUDE:  Including 'const-form-xs.inc' from 'curl-Form-xs.inc' */


/* INCLUDE: Returning to 'curl-Form-xs.inc' from 'const-form-xs.inc' */


XS_EUPXS(XS_Net__Curl__Form_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Form_new)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 2)
       croak_xs_usage(cv,  "sclass=\"Net::Curl::Form\", base=HASHREF_BY_DEFAULT");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	sclass;
	SV *	base;
#line 122 "./curl-Form-xs.inc"
		perl_curl_form_t *form;
		HV *stash;
#line 1619 "Curl.c"

	if (items < 1)
	    sclass = "Net::Curl::Form";
	else {
	    sclass = (const char *)SvPV_nolen(ST(0))
;
	}

	if (items < 2)
	    base = HASHREF_BY_DEFAULT;
	else {
	    base = ST(1)
;
	}
#line 125 "./curl-Form-xs.inc"
		if ( ! SvOK( base ) || ! SvROK( base ) )
			croak( "object base must be a valid reference\n" );

		form = perl_curl_form_new();
		perl_curl_setptr( aTHX_ base, &perl_curl_form_vtbl, form );

		stash = gv_stashpv( sclass, 0 );
		ST(0) = sv_bless( base, stash );

		form->perl_self = SvRV( ST(0) );

		XSRETURN(1);
#line 1647 "Curl.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__Curl__Form_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Form_add)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "form, ...");
    {
	Net__Curl__Form	form = (Net__Curl__Form) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_form_vtbl,
		"form", "Net::Curl::Form" )
;
#line 144 "./curl-Form-xs.inc"
		struct curl_forms *farray;
		int i_in, i_out;
		CURLFORMcode ret;
#line 1669 "Curl.c"
#line 148 "./curl-Form-xs.inc"
		if ( !( items & 1 ) && (
				!SvOK( ST( items - 1 ) ) ||
				SvIV( ST( items - 1 ) ) != CURLFORM_END ) )
			croak( "Expected even number of arguments" );

		form->adds++;

		/* items is about twice as much as we'll normally use */
		Newx( farray, items, struct curl_forms );

		for ( i_in = 1, i_out = 0; i_in < items - 1; i_in += 2 ) {
			int option = SvIV( ST( i_in ) );
			SV *value = ST( i_in + 1 );
			int option_len = 0;
			char *buf = NULL;
			STRLEN len = 0;
			switch ( option ) {
				/* set string and its length */
				case CURLFORM_PTRNAME:
					option = CURLFORM_COPYNAME;
				case CURLFORM_COPYNAME:
					option_len = CURLFORM_NAMELENGTH;
					buf = SvPV( value, len );
					goto case_datawithzero;

				case CURLFORM_PTRCONTENTS:
					option = CURLFORM_COPYCONTENTS;
				case CURLFORM_COPYCONTENTS:
					option_len = CURLFORM_CONTENTSLENGTH;
					buf = SvPV( value, len );
					goto case_datawithzero;

				case CURLFORM_BUFFERPTR:
					option_len = CURLFORM_BUFFERLENGTH;
					if ( SvOK( value ) && SvROK( value ) )
						value = SvRV( value );
					{
						char **bufp = perl_curl_simplell_add( aTHX_
							&form->buffers, ( form->adds << 16 | i_out ) );
						char *src = SvPV( value, len );
						*bufp = buf = savepvn( src, len );
					}

				case_datawithzero:
					farray[ i_out ].option = option;
					farray[ i_out ].value = buf;
					i_out++;
					farray[ i_out ].option = option_len;
					farray[ i_out ].value = (void *) len;
					i_out++;
					break;

				case CURLFORM_NAMELENGTH:
				case CURLFORM_CONTENTSLENGTH:
				case CURLFORM_BUFFERLENGTH:
					if ( i_out > 0 && farray[ i_out - 1 ].option == option ) {
						if ( PTR2IV( farray[ i_out - 1 ].value ) < SvIV( value ) )
							croak( "specified length larger than data size" );
						i_out--;
					}
					farray[ i_out ].option = option;
					farray[ i_out ].value = INT2PTR( void *, SvIV( value ) );
					i_out++;
					break;

				case CURLFORM_FILECONTENT:
				case CURLFORM_FILE:
				case CURLFORM_CONTENTTYPE:
				case CURLFORM_FILENAME:
				case CURLFORM_BUFFER:
					farray[ i_out ].option = option;
					farray[ i_out ].value = SvPV_nolen( value );
					i_out++;
					break;

				case CURLFORM_CONTENTHEADER:
					{
						struct curl_slist **pslist;
						pslist = perl_curl_simplell_add( aTHX_ &form->slists,
							( form->adds << 16 | i_out ) );
						*pslist = perl_curl_array2slist( aTHX_ NULL, value );

						farray[ i_out ].option = option;
						farray[ i_out ].value = (void *) *pslist;
						i_out++;
					}
					break;

				default:
					croak( "curl_formadd option %d is not supported", option );
					break;
			}
		}
		farray[ i_out ].option = CURLFORM_END;

		ret = curl_formadd( &form->post, &form->last,
			CURLFORM_ARRAY, farray, CURLFORM_END );

		Safefree( farray );

		if ( ret != CURL_FORMADD_OK )
			die_code( "Form", ret );
#line 1773 "Curl.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl__Form_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Form_get)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "form, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Curl__Form	form = (Net__Curl__Form) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_form_vtbl,
		"form", "Net::Curl::Form" )
;
#line 257 "./curl-Form-xs.inc"
		SV *output;
#line 1794 "Curl.c"
#line 259 "./curl-Form-xs.inc"
		CLEAR_ERRSV();

		if ( items < 2 ) {
			output = sv_2mortal( newSVpv( "", 0 ) );
			curl_formget( form->post, output, cb_form_get_sv );

			/* rethrow errors */
			if ( SvTRUE( ERRSV ) )
				croak( NULL );

			ST(0) = output;
			XSRETURN(1);

		} else if ( items < 3 ) {
			output = ST(1);

			if ( SvROK( output ) )
				output = SvRV( output );

			if ( SvTYPE( output ) == SVt_PVGV ) {
				PerlIO *handle = IoOFP( sv_2io( output ) );
				curl_formget( form->post, handle, cb_form_get_io );
			} else if ( !SvREADONLY( output ) ) {
				curl_formget( form->post, output, cb_form_get_sv );
			} else {
				croak( "output buffer is invalid" );
			}

			/* rethrow errors */
			if ( SvTRUE( ERRSV ) )
				croak( NULL );

			XSRETURN(0);

		} else {
			form->cb[ CB_FORM_GET ].data = ST(1);
			form->cb[ CB_FORM_GET ].func = ST(2);
			curl_formget( form->post, form, cb_form_get_code );

			/* rethrow errors */
			if ( SvTRUE( ERRSV ) )
				croak( NULL );

			XSRETURN(0);
		}
#line 1841 "Curl.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__Curl__Form_CLONE_SKIP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Form_CLONE_SKIP)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	SV *	pkg = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 310 "./curl-Form-xs.inc"
		(void ) pkg;
		RETVAL = 1;
#line 1862 "Curl.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'curl-Easy-xs.inc' from 'curl-Form-xs.inc' */


/* INCLUDE:  Including 'const-easy-xs.inc' from 'curl-Easy-xs.inc' */


/* INCLUDE: Returning to 'curl-Easy-xs.inc' from 'const-easy-xs.inc' */


XS_EUPXS(XS_Net__Curl__Easy_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_new)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 2)
       croak_xs_usage(cv,  "sclass=\"Net::Curl::Easy\", base=HASHREF_BY_DEFAULT");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	sclass;
	SV *	base;
#line 284 "./curl-Easy-xs.inc"
		perl_curl_easy_t *easy;
		HV *stash;
#line 1893 "Curl.c"

	if (items < 1)
	    sclass = "Net::Curl::Easy";
	else {
	    sclass = (const char *)SvPV_nolen(ST(0))
;
	}

	if (items < 2)
	    base = HASHREF_BY_DEFAULT;
	else {
	    base = ST(1)
;
	}
#line 287 "./curl-Easy-xs.inc"
		if ( ! SvOK( base ) || ! SvROK( base ) )
			croak( "object base must be a valid reference\n" );

		easy = perl_curl_easy_new();
		perl_curl_easy_preset( easy );

		perl_curl_setptr( aTHX_ base, &perl_curl_easy_vtbl, easy );
		stash = gv_stashpv( sclass, 0 );
		ST(0) = sv_bless( base, stash );

		easy->perl_self = SvRV( ST(0) );

		XSRETURN(1);
#line 1922 "Curl.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__Curl__Easy_duphandle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_duphandle)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "easy, base=HASHREF_BY_DEFAULT");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	SV *	base;
#line 307 "./curl-Easy-xs.inc"
		perl_curl_easy_t *clone;
		const char *sclass;
		perl_curl_easy_callback_code_t i;
		HV *stash;
#line 1948 "Curl.c"

	if (items < 2)
	    base = HASHREF_BY_DEFAULT;
	else {
	    base = ST(1)
;
	}
#line 312 "./curl-Easy-xs.inc"
		if ( ! SvOK( base ) || ! SvROK( base ) )
			croak( "object base must be a valid reference\n" );

		sclass = sv_reftype( SvRV( ST(0) ), TRUE );
		clone = perl_curl_easy_duphandle( easy );

		perl_curl_easy_preset( clone );

		if ( easy->cb[ CB_EASY_HEADER ].func
				|| easy->cb[ CB_EASY_HEADER ].data ) {
			curl_easy_setopt( clone->handle, CURLOPT_HEADERFUNCTION, cb_easy_header );
			curl_easy_setopt( clone->handle, CURLOPT_WRITEHEADER, clone );
		}

		if ( easy->cb[ CB_EASY_PROGRESS ].func ) {
			curl_easy_setopt( clone->handle, CURLOPT_PROGRESSFUNCTION, cb_easy_progress );
			curl_easy_setopt( clone->handle, CURLOPT_PROGRESSDATA, clone );
		}
		//
#ifdef CURLOPT_XFERINFOFUNCTION
# ifdef CURLOPT_XFERINFODATA
		if ( easy->cb[ CB_EASY_XFERINFO ].func ) {
			curl_easy_setopt( clone->handle, CURLOPT_XFERINFOFUNCTION, cb_easy_xferinfo );
			curl_easy_setopt( clone->handle, CURLOPT_XFERINFODATA, clone );
		}
# endif
#endif

		if ( easy->cb[ CB_EASY_DEBUG ].func ) {
			curl_easy_setopt( clone->handle, CURLOPT_DEBUGFUNCTION, cb_easy_debug );
			curl_easy_setopt( clone->handle, CURLOPT_DEBUGDATA, clone );
		}

		for( i = 0; i < CB_EASY_LAST; i++ ) {
			SvREPLACE( clone->cb[i].func, easy->cb[i].func );
			SvREPLACE( clone->cb[i].data, easy->cb[i].data );
		};

		/* clone strings and set */
		if ( easy->strings ) {
			simplell_t *in, **out;
			in = easy->strings;
			out = &clone->strings;
			do {
				Newx( *out, 1, simplell_t );
				(*out)->next = NULL;
				(*out)->key = in->key;
				(*out)->value = savepv( in->value );

				curl_easy_setopt( clone->handle, in->key, (*out)->value );
				out = &(*out)->next;
				in = in->next;
			} while ( in != NULL );
		}

		/* clone slists and set */
		if ( easy->slists ) {
			simplell_t *in, **out;
			struct curl_slist *sin, *sout;
			in = easy->slists;
			out = &clone->slists;
			do {
				Newx( *out, 1, simplell_t );
				sout = NULL;
				sin = in->value;
				do {
					sout = curl_slist_append( sout, sin->data );
				} while ( ( sin = sin->next ) != NULL );

				(*out)->next = NULL;
				(*out)->key = in->key;
				(*out)->value = sout;

				curl_easy_setopt( clone->handle, in->key, (*out)->value );
				out = &(*out)->next;
				in = in->next;
			} while ( in != NULL );
		}

		if ( easy->share_sv ) {
			perl_curl_share_t *share;
			share = perl_curl_getptr( aTHX_ easy->share_sv,
				&perl_curl_share_vtbl );

			clone->share_sv = newSVsv( easy->share_sv );
			curl_easy_setopt( clone->handle, CURLOPT_SHARE, share->handle );
		}

		if ( easy->form_sv ) {
			perl_curl_form_t *form;
			form = perl_curl_getptr( aTHX_ easy->form_sv,
				&perl_curl_form_vtbl );

			clone->form_sv = newSVsv( easy->form_sv );
			curl_easy_setopt( clone->handle, CURLOPT_HTTPPOST, form->post );
		}

		perl_curl_setptr( aTHX_ base, &perl_curl_easy_vtbl, clone );
		stash = gv_stashpv( sclass, 0 );
		ST(0) = sv_bless( base, stash );

		clone->perl_self = SvRV( ST(0) );

		XSRETURN(1);
#line 2061 "Curl.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__Curl__Easy_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "easy");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
#line 422 "./curl-Easy-xs.inc"
		curl_easy_reset( easy->handle );
		perl_curl_easy_preset( easy );
#line 2082 "Curl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__Curl__Easy_setopt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_setopt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "easy, option, value");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	int	option = (int)SvIV(ST(1))
;
	SV *	value = ST(2)
;
#line 432 "./curl-Easy-xs.inc"
		int opttype;
#line 2105 "Curl.c"
#line 434 "./curl-Easy-xs.inc"
		opttype = option - option % CURLOPTTYPE_OBJECTPOINT;
		if ( opttype == CURLOPTTYPE_LONG ) {
			perl_curl_easy_setopt_long( aTHX_ easy, option, value );
		} else if ( opttype == CURLOPTTYPE_OBJECTPOINT ) {
			perl_curl_easy_setopt_object( aTHX_ easy, option, value );
		} else if ( opttype == CURLOPTTYPE_FUNCTIONPOINT ) {
			perl_curl_easy_setopt_function( aTHX_ easy, option, value );
		} else if ( opttype == CURLOPTTYPE_OFF_T ) {
			perl_curl_easy_setopt_off_t( aTHX_ easy, option, value );
#ifdef CURLOPTTYPE_BLOB
		} else if ( opttype == CURLOPTTYPE_BLOB ) {
			perl_curl_easy_setopt_blob( aTHX_ easy, option, value );
#endif
		} else {
			perl_curl_croak_invalid_option(aTHX_ option);
		}
#line 2123 "Curl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__Curl__Easy_perform); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_perform)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "easy");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
#line 456 "./curl-Easy-xs.inc"
		CURLcode ret;
#line 2142 "Curl.c"
#line 458 "./curl-Easy-xs.inc"
		CLEAR_ERRSV();
		ret = curl_easy_perform( easy->handle );

		/* rethrow errors */
		if ( SvTRUE( ERRSV ) )
			croak( NULL );

		EASY_DIE( ret );
#line 2152 "Curl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__Curl__Easy_getinfo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_getinfo)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "easy, option");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	int	option = (int)SvIV(ST(1))
;
	SV *	RETVAL;
#line 473 "./curl-Easy-xs.inc"
		switch ( option & CURLINFO_TYPEMASK ) {
			case CURLINFO_STRING:
			{
				CURLcode ret;
				char * vchar;
				if ( option == CURLINFO_PRIVATE )
					croak( "CURLINFO_PRIVATE is not available, use your base object" );

				ret = curl_easy_getinfo( easy->handle, option, &vchar );
				EASY_DIE( ret );
				RETVAL = newSVpv( vchar, 0 );
				break;
			}
			case CURLINFO_LONG:
			{
				CURLcode ret;
				long vlong;
				ret = curl_easy_getinfo( easy->handle, option, &vlong );
				EASY_DIE( ret );
				RETVAL = newSViv( vlong );
				break;
			}
			case CURLINFO_DOUBLE:
			{
				CURLcode ret;
				double vdouble;
				ret = curl_easy_getinfo( easy->handle, option, &vdouble );
				EASY_DIE( ret );
				RETVAL = newSVnv( vdouble );
				break;
			}
			case CURLINFO_SLIST:
			{
				CURLcode ret;
				struct curl_slist *entry;
				AV *items = NULL;
#ifdef CURLINFO_CERTINFO
				if ( option == CURLINFO_CERTINFO ) {
					struct curl_certinfo *ci;
					ret = curl_easy_getinfo( easy->handle, option, &ci );
					EASY_DIE( ret );

					items = newAV();

					if (ci->num_of_certs) {
						av_extend( items, ci->num_of_certs - 1 );
						int i;

						for (i = 0; i < ci->num_of_certs; i++) {
							HV *certhv = newHV();
							char *colon;

							av_store( items, i, newRV_noinc( (SV *) certhv ) );

							for (entry = ci->certinfo[i]; entry; entry = entry->next) {
								colon = strchr(entry->data, ':');

								if (colon == NULL) {
									warn("No colon found: %s", entry->data);
								}
								else {
									hv_store(
										certhv,
										entry->data,
										colon - entry->data,
										newSVpv(1 + colon, 0),
										0
									);
								}
							}
						}
					}

					RETVAL = newRV_noinc( (SV *) items );
				}
				else {
#endif
				struct curl_slist *vlist;
				ret = curl_easy_getinfo( easy->handle, option, &vlist );
				EASY_DIE( ret );

				if ( vlist != NULL ) {
					items = newAV();
					entry = vlist;
					while ( entry ) {
						av_push( items, newSVpv( entry->data, 0 ) );
						entry = entry->next;
					}
					curl_slist_free_all( vlist );
					RETVAL = newRV( sv_2mortal( (SV *) items ) );
				} else {
					RETVAL = &PL_sv_undef;
				}
#ifdef CURLINFO_CERTINFO
				}
#endif
				break;
			}
			default: {
				croak( "invalid getinfo option" );
				break;
			}
		}
#line 2276 "Curl.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#if LIBCURL_VERSION_NUM >= 0x071200
#define XSubPPtmpAAAC 1


XS_EUPXS(XS_Net__Curl__Easy_pause); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_pause)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "easy, bitmask");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	int	bitmask = (int)SvIV(ST(1))
;
#line 587 "./curl-Easy-xs.inc"
		CURLcode ret;
		ret = curl_easy_pause( easy, bitmask );
		EASY_DIE( ret );
#line 2304 "Curl.c"
    }
    XSRETURN_EMPTY;
}

#endif
#if LIBCURL_VERSION_NUM >= 0x071202
#define XSubPPtmpAAAD 1


XS_EUPXS(XS_Net__Curl__Easy_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_send)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "easy, buffer");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	SV *	buffer = ST(1)
;
	size_t	RETVAL;
	dXSTARG;
#line 600 "./curl-Easy-xs.inc"
		CURLcode ret;
		STRLEN len;
		const char *pv;
		size_t out_len;

		if ( ! SvOK( buffer ) )
			croak( "buffer is not valid\n" );

		pv = SvPV( buffer, len );
		ret = curl_easy_send( easy->handle, pv, len, &out_len );
		EASY_DIE( ret );

		RETVAL = out_len;
#line 2343 "Curl.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl__Easy_recv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_recv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "easy, buffer, length");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	SV *	buffer = ST(1)
;
	size_t	length = (size_t)SvUV(ST(2))
;
	size_t	RETVAL;
	dXSTARG;
#line 623 "./curl-Easy-xs.inc"
		CURLcode ret;
		size_t out_len;
		char *tmpbuf;

		if ( !SvOK( buffer ) )
			sv_setpvn( buffer, "", 0 );

		if ( !SvPOK( buffer ) ) {
			SvPV_nolen( buffer );
			if ( !SvPOK( buffer ) )
				croak( "internal Net::Curl error" );
		}

		Sv_Grow( buffer, SvCUR( buffer ) + length + 1 );

		tmpbuf = SvEND( buffer );

		ret = curl_easy_recv( easy->handle, tmpbuf, length, &out_len );
		EASY_DIE( ret );

		SvCUR_set( buffer, SvCUR( buffer ) + out_len );

		RETVAL = out_len;
#line 2392 "Curl.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Net__Curl__Easy_strerror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_strerror)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 656 "./curl-Easy-xs.inc"
		const char *errstr;
#line 2410 "Curl.c"
	SV *	RETVAL;
#line 658 "./curl-Easy-xs.inc"
		if ( items < 1 || items > 2 )
			croak( "Usage: Net::Curl::Easy::strerror( [easy], errnum )" );
		errstr = curl_easy_strerror( SvIV( ST( items - 1 ) ) );
		RETVAL = newSVpv( errstr, 0 );
#line 2417 "Curl.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl__Easy_unescape); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_unescape)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "easy, url");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	SV *	url = ST(1)
;
#line 671 "./curl-Easy-xs.inc"
		STRLEN length;
		char *in_string;
		int out_length;
		char *out_string;
#line 2443 "Curl.c"
	SV *	RETVAL;
#line 676 "./curl-Easy-xs.inc"
		if ( !SvOK( url ) )
			XSRETURN_UNDEF;
#line 2448 "Curl.c"
#line 679 "./curl-Easy-xs.inc"
		in_string = SvPV( url, length );
		out_string = curl_easy_unescape( easy->handle, in_string, length, &out_length );
		if ( !out_string )
			XSRETURN_UNDEF;
		RETVAL = newSVpv( out_string, out_length );
		curl_free( out_string );
#line 2456 "Curl.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl__Easy_escape); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_escape)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "easy, url");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	SV *	url = ST(1)
;
#line 693 "./curl-Easy-xs.inc"
		STRLEN length;
		char *in_string;
		char *out_string;
#line 2481 "Curl.c"
	SV *	RETVAL;
#line 697 "./curl-Easy-xs.inc"
		if ( !SvOK( url ) )
			XSRETURN_UNDEF;
#line 2486 "Curl.c"
#line 700 "./curl-Easy-xs.inc"
		in_string = SvPV( url, length );
		out_string = curl_easy_escape( easy->handle, in_string, length );
		if ( !out_string )
			XSRETURN_UNDEF;
		RETVAL = newSVpv( out_string, 0 );
		curl_free( out_string );
#line 2494 "Curl.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl__Easy_pushopt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_pushopt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "easy, option, value");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	int	option = (int)SvIV(ST(1))
;
	SV *	value = ST(2)
;
#line 718 "./curl-Easy-xs.inc"
		CURLcode ret;
#line 2519 "Curl.c"
#line 720 "./curl-Easy-xs.inc"
		ret = perl_curl_easy_setoptslist( aTHX_ easy, option, value, 0 );
		EASY_DIE( ret );
#line 2523 "Curl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__Curl__Easy_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_error)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "easy");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	char *	RETVAL;
	dXSTARG;
#line 728 "./curl-Easy-xs.inc"
		RETVAL = easy->errbuf;
#line 2544 "Curl.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl__Easy_multi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_multi)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "easy");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	SV *	RETVAL;
#line 737 "./curl-Easy-xs.inc"
		RETVAL = easy->multi ? SELF2PERL( easy->multi ) : &PL_sv_undef;
#line 2567 "Curl.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl__Easy_share); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_share)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "easy");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	SV *	RETVAL;
#line 746 "./curl-Easy-xs.inc"
		RETVAL = easy->share_sv ? newSVsv( easy->share_sv ) : &PL_sv_undef;
#line 2589 "Curl.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl__Easy_form); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_form)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "easy");
    {
	Net__Curl__Easy	easy = (Net__Curl__Easy) perl_curl_getptr_fatal( aTHX_ ST(0),
		&perl_curl_easy_vtbl,
		"easy", "Net::Curl::Easy" )
;
	SV *	RETVAL;
#line 755 "./curl-Easy-xs.inc"
		RETVAL = easy->form_sv ? newSVsv( easy->form_sv ) : &PL_sv_undef;
#line 2611 "Curl.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__Curl__Easy_CLONE_SKIP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__Curl__Easy_CLONE_SKIP)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	SV *	pkg = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 764 "./curl-Easy-xs.inc"
		(void) pkg;
		RETVAL = 1;
#line 2633 "Curl.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'Curl.xs' from 'curl-Easy-xs.inc' */

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Net__Curl); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__Curl)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Net::Curl::getdate", XS_Net__Curl_getdate, file, "$");
        (void)newXSproto_portable("Net::Curl::version", XS_Net__Curl_version, file, "");
        (void)newXSproto_portable("Net::Curl::version_info", XS_Net__Curl_version_info, file, "");
        (void)newXSproto_portable("Net::Curl::Share::new", XS_Net__Curl__Share_new, file, ";$$");
        (void)newXSproto_portable("Net::Curl::Share::setopt", XS_Net__Curl__Share_setopt, file, "$$$");
        (void)newXSproto_portable("Net::Curl::Share::strerror", XS_Net__Curl__Share_strerror, file, "$;$");
        (void)newXSproto_portable("Net::Curl::Multi::new", XS_Net__Curl__Multi_new, file, ";$$");
        (void)newXSproto_portable("Net::Curl::Multi::add_handle", XS_Net__Curl__Multi_add_handle, file, "$$");
        (void)newXSproto_portable("Net::Curl::Multi::remove_handle", XS_Net__Curl__Multi_remove_handle, file, "$$");
        (void)newXSproto_portable("Net::Curl::Multi::info_read", XS_Net__Curl__Multi_info_read, file, "$");
        (void)newXSproto_portable("Net::Curl::Multi::fdset", XS_Net__Curl__Multi_fdset, file, "$");
        (void)newXSproto_portable("Net::Curl::Multi::timeout", XS_Net__Curl__Multi_timeout, file, "$");
        (void)newXSproto_portable("Net::Curl::Multi::setopt", XS_Net__Curl__Multi_setopt, file, "$$$");
        (void)newXSproto_portable("Net::Curl::Multi::perform", XS_Net__Curl__Multi_perform, file, "$");
#if XSubPPtmpAAAA
        (void)newXSproto_portable("Net::Curl::Multi::wait", XS_Net__Curl__Multi_wait, file, "$;$$");
#endif
        (void)newXSproto_portable("Net::Curl::Multi::socket_action", XS_Net__Curl__Multi_socket_action, file, "$;$$");
#if XSubPPtmpAAAB
        (void)newXSproto_portable("Net::Curl::Multi::assign", XS_Net__Curl__Multi_assign, file, "$$;$");
#endif
        (void)newXSproto_portable("Net::Curl::Multi::strerror", XS_Net__Curl__Multi_strerror, file, "$;$");
        (void)newXSproto_portable("Net::Curl::Multi::handles", XS_Net__Curl__Multi_handles, file, "$");
        (void)newXSproto_portable("Net::Curl::Multi::CLONE_SKIP", XS_Net__Curl__Multi_CLONE_SKIP, file, "$");
        (void)newXSproto_portable("Net::Curl::Form::new", XS_Net__Curl__Form_new, file, ";$$");
        (void)newXSproto_portable("Net::Curl::Form::add", XS_Net__Curl__Form_add, file, "$%");
        (void)newXSproto_portable("Net::Curl::Form::get", XS_Net__Curl__Form_get, file, "$;$&");
        (void)newXSproto_portable("Net::Curl::Form::CLONE_SKIP", XS_Net__Curl__Form_CLONE_SKIP, file, "$");
        (void)newXSproto_portable("Net::Curl::Easy::new", XS_Net__Curl__Easy_new, file, ";$$");
        (void)newXSproto_portable("Net::Curl::Easy::duphandle", XS_Net__Curl__Easy_duphandle, file, "$;$");
        (void)newXSproto_portable("Net::Curl::Easy::reset", XS_Net__Curl__Easy_reset, file, "$");
        (void)newXSproto_portable("Net::Curl::Easy::setopt", XS_Net__Curl__Easy_setopt, file, "$$$");
        (void)newXSproto_portable("Net::Curl::Easy::perform", XS_Net__Curl__Easy_perform, file, "$");
        (void)newXSproto_portable("Net::Curl::Easy::getinfo", XS_Net__Curl__Easy_getinfo, file, "$$");
#if XSubPPtmpAAAC
        (void)newXSproto_portable("Net::Curl::Easy::pause", XS_Net__Curl__Easy_pause, file, "$$");
#endif
#if XSubPPtmpAAAD
        (void)newXSproto_portable("Net::Curl::Easy::send", XS_Net__Curl__Easy_send, file, "$$");
        (void)newXSproto_portable("Net::Curl::Easy::recv", XS_Net__Curl__Easy_recv, file, "$$$");
#endif
        (void)newXSproto_portable("Net::Curl::Easy::strerror", XS_Net__Curl__Easy_strerror, file, "$;$");
        (void)newXSproto_portable("Net::Curl::Easy::unescape", XS_Net__Curl__Easy_unescape, file, "$$");
        (void)newXSproto_portable("Net::Curl::Easy::escape", XS_Net__Curl__Easy_escape, file, "$$");
        (void)newXSproto_portable("Net::Curl::Easy::pushopt", XS_Net__Curl__Easy_pushopt, file, "$$$");
        (void)newXSproto_portable("Net::Curl::Easy::error", XS_Net__Curl__Easy_error, file, "$");
        (void)newXSproto_portable("Net::Curl::Easy::multi", XS_Net__Curl__Easy_multi, file, "$");
        (void)newXSproto_portable("Net::Curl::Easy::share", XS_Net__Curl__Easy_share, file, "$");
        (void)newXSproto_portable("Net::Curl::Easy::form", XS_Net__Curl__Easy_form, file, "$");
        (void)newXSproto_portable("Net::Curl::Easy::CLONE_SKIP", XS_Net__Curl__Easy_CLONE_SKIP, file, "$");

    /* Initialisation Section */

#line 474 "Curl.xs"
	{
		/* XXX 1: this is _not_ thread safe */
		/* XXX 2: should never be called from a thread */
		static int run_once = 0;
		if ( !run_once++ ) {
			curl_global_init( CURL_GLOBAL_ALL );
			atexit( curl_global_cleanup );
		}
	}
	{
		dTHX;
		HV *symbol_table = get_hv( "Net::Curl::", GV_ADD );
		static const struct iv_s values_for_iv[] = {
			IV_CONST( LIBCURL_VERSION_MAJOR ),
			IV_CONST( LIBCURL_VERSION_MINOR ),
			IV_CONST( LIBCURL_VERSION_PATCH ),
			IV_CONST( LIBCURL_VERSION_NUM ),
			{ NULL, 0, 0 }
		};
		static const struct pv_s values_for_pv[] = {
			PV_CONST( LIBCURL_COPYRIGHT ),
			PV_CONST( LIBCURL_VERSION ),
			PV_CONST( LIBCURL_TIMESTAMP ),
			{ NULL, 0, NULL, 0 }
		};
		const struct iv_s *value_for_iv = values_for_iv;
		const struct pv_s *value_for_pv = values_for_pv;
		while ( value_for_iv->name ) {
			perl_curl_constant_add( aTHX_ symbol_table,
				value_for_iv->name, value_for_iv->namelen,
				newSViv( value_for_iv->value ) );
			++value_for_iv;
		}
		while ( value_for_pv->name ) {
			perl_curl_constant_add( aTHX_ symbol_table,
				value_for_pv->name, value_for_pv->namelen,
				newSVpvn( value_for_pv->value, value_for_pv->valuelen ) );
			++value_for_pv;
		}


		++PL_sub_generation;
	}

#line 2 "./const-curl-xs.inc"
	{
		dTHX;
		HV *symbol_table = get_hv( "Net::Curl::", GV_ADD );
		static const struct iv_s values_for_iv[] = {
			{ "CURLVERSION_EIGHTH", 18, CURLVERSION_EIGHTH },
			{ "CURLVERSION_ELEVENTH", 20, CURLVERSION_ELEVENTH },
			{ "CURLVERSION_FIFTH", 17, CURLVERSION_FIFTH },
			{ "CURLVERSION_FIRST", 17, CURLVERSION_FIRST },
			{ "CURLVERSION_FOURTH", 18, CURLVERSION_FOURTH },
			{ "CURLVERSION_NINTH", 17, CURLVERSION_NINTH },
			{ "CURLVERSION_NOW", 15, CURLVERSION_NOW },
			{ "CURLVERSION_SECOND", 18, CURLVERSION_SECOND },
			{ "CURLVERSION_SEVENTH", 19, CURLVERSION_SEVENTH },
			{ "CURLVERSION_SIXTH", 17, CURLVERSION_SIXTH },
			{ "CURLVERSION_TENTH", 17, CURLVERSION_TENTH },
			{ "CURLVERSION_THIRD", 17, CURLVERSION_THIRD },
			{ "CURLVERSION_TWELFTH", 19, CURLVERSION_TWELFTH },
			{ "CURL_VERSION_ALTSVC", 19, CURL_VERSION_ALTSVC },
			{ "CURL_VERSION_ASYNCHDNS", 22, CURL_VERSION_ASYNCHDNS },
			{ "CURL_VERSION_BROTLI", 19, CURL_VERSION_BROTLI },
			{ "CURL_VERSION_CONV", 17, CURL_VERSION_CONV },
			{ "CURL_VERSION_CURLDEBUG", 22, CURL_VERSION_CURLDEBUG },
			{ "CURL_VERSION_DEBUG", 18, CURL_VERSION_DEBUG },
			{ "CURL_VERSION_GSASL", 18, CURL_VERSION_GSASL },
			{ "CURL_VERSION_GSSAPI", 19, CURL_VERSION_GSSAPI },
			{ "CURL_VERSION_GSSNEGOTIATE", 25, CURL_VERSION_GSSNEGOTIATE },
			{ "CURL_VERSION_HSTS", 17, CURL_VERSION_HSTS },
			{ "CURL_VERSION_HTTP2", 18, CURL_VERSION_HTTP2 },
			{ "CURL_VERSION_HTTP3", 18, CURL_VERSION_HTTP3 },
			{ "CURL_VERSION_HTTPS_PROXY", 24, CURL_VERSION_HTTPS_PROXY },
			{ "CURL_VERSION_IDN", 16, CURL_VERSION_IDN },
			{ "CURL_VERSION_IPV6", 17, CURL_VERSION_IPV6 },
			{ "CURL_VERSION_KERBEROS4", 22, CURL_VERSION_KERBEROS4 },
			{ "CURL_VERSION_KERBEROS5", 22, CURL_VERSION_KERBEROS5 },
			{ "CURL_VERSION_LARGEFILE", 22, CURL_VERSION_LARGEFILE },
			{ "CURL_VERSION_LIBZ", 17, CURL_VERSION_LIBZ },
			{ "CURL_VERSION_MULTI_SSL", 22, CURL_VERSION_MULTI_SSL },
			{ "CURL_VERSION_NTLM", 17, CURL_VERSION_NTLM },
			{ "CURL_VERSION_NTLM_WB", 20, CURL_VERSION_NTLM_WB },
			{ "CURL_VERSION_PSL", 16, CURL_VERSION_PSL },
			{ "CURL_VERSION_SPNEGO", 19, CURL_VERSION_SPNEGO },
			{ "CURL_VERSION_SSL", 16, CURL_VERSION_SSL },
			{ "CURL_VERSION_SSPI", 17, CURL_VERSION_SSPI },
			{ "CURL_VERSION_THREADSAFE", 23, CURL_VERSION_THREADSAFE },
			{ "CURL_VERSION_TLSAUTH_SRP", 24, CURL_VERSION_TLSAUTH_SRP },
			{ "CURL_VERSION_UNICODE", 20, CURL_VERSION_UNICODE },
			{ "CURL_VERSION_UNIX_SOCKETS", 25, CURL_VERSION_UNIX_SOCKETS },
			{ "CURL_VERSION_ZSTD", 17, CURL_VERSION_ZSTD },
			{ NULL, 0, 0 }
		};
		const struct iv_s *value_for_iv = values_for_iv;
		while ( value_for_iv->name ) {
			perl_curl_constant_add(aTHX_ symbol_table, value_for_iv->name,
				value_for_iv->namelen, newSViv( value_for_iv->value ) );
			++value_for_iv;
		}

		++PL_sub_generation;
	}

#line 2 "./const-share-xs.inc"
	{
		dTHX;
		HV *symbol_table = get_hv( "Net::Curl::Share::", GV_ADD );
		static const struct iv_s values_for_iv[] = {
			{ "CURLSHOPT_LOCKFUNC", 18, CURLSHOPT_LOCKFUNC },
			{ "CURLSHOPT_NONE", 14, CURLSHOPT_NONE },
			{ "CURLSHOPT_SHARE", 15, CURLSHOPT_SHARE },
			{ "CURLSHOPT_UNLOCKFUNC", 20, CURLSHOPT_UNLOCKFUNC },
			{ "CURLSHOPT_UNSHARE", 17, CURLSHOPT_UNSHARE },
			{ "CURLSHOPT_USERDATA", 18, CURLSHOPT_USERDATA },
			{ "CURL_LOCK_ACCESS_NONE", 21, CURL_LOCK_ACCESS_NONE },
			{ "CURL_LOCK_ACCESS_SHARED", 23, CURL_LOCK_ACCESS_SHARED },
			{ "CURL_LOCK_ACCESS_SINGLE", 23, CURL_LOCK_ACCESS_SINGLE },
			{ "CURL_LOCK_DATA_CONNECT", 22, CURL_LOCK_DATA_CONNECT },
			{ "CURL_LOCK_DATA_COOKIE", 21, CURL_LOCK_DATA_COOKIE },
			{ "CURL_LOCK_DATA_DNS", 18, CURL_LOCK_DATA_DNS },
			{ "CURL_LOCK_DATA_HSTS", 19, CURL_LOCK_DATA_HSTS },
			{ "CURL_LOCK_DATA_NONE", 19, CURL_LOCK_DATA_NONE },
			{ "CURL_LOCK_DATA_PSL", 18, CURL_LOCK_DATA_PSL },
			{ "CURL_LOCK_DATA_SHARE", 20, CURL_LOCK_DATA_SHARE },
			{ "CURL_LOCK_DATA_SSL_SESSION", 26, CURL_LOCK_DATA_SSL_SESSION },
			{ NULL, 0, 0 }
		};
		const struct iv_s *value_for_iv = values_for_iv;
		while ( value_for_iv->name ) {
			perl_curl_constant_add(aTHX_ symbol_table, value_for_iv->name,
				value_for_iv->namelen, newSViv( value_for_iv->value ) );
			++value_for_iv;
		}

		++PL_sub_generation;
	}

#line 2 "./const-multi-xs.inc"
	{
		dTHX;
		HV *symbol_table = get_hv( "Net::Curl::Multi::", GV_ADD );
		static const struct iv_s values_for_iv[] = {
			{ "CURLMOPT_CHUNK_LENGTH_PENALTY_SIZE", 34, CURLMOPT_CHUNK_LENGTH_PENALTY_SIZE },
			{ "CURLMOPT_CONTENT_LENGTH_PENALTY_SIZE", 36, CURLMOPT_CONTENT_LENGTH_PENALTY_SIZE },
			{ "CURLMOPT_MAXCONNECTS", 20, CURLMOPT_MAXCONNECTS },
			{ "CURLMOPT_MAX_CONCURRENT_STREAMS", 31, CURLMOPT_MAX_CONCURRENT_STREAMS },
			{ "CURLMOPT_MAX_HOST_CONNECTIONS", 29, CURLMOPT_MAX_HOST_CONNECTIONS },
			{ "CURLMOPT_MAX_PIPELINE_LENGTH", 28, CURLMOPT_MAX_PIPELINE_LENGTH },
			{ "CURLMOPT_MAX_TOTAL_CONNECTIONS", 30, CURLMOPT_MAX_TOTAL_CONNECTIONS },
			{ "CURLMOPT_PIPELINING", 19, CURLMOPT_PIPELINING },
			{ "CURLMOPT_PIPELINING_SERVER_BL", 29, CURLMOPT_PIPELINING_SERVER_BL },
			{ "CURLMOPT_PIPELINING_SITE_BL", 27, CURLMOPT_PIPELINING_SITE_BL },
			{ "CURLMOPT_PUSHDATA", 17, CURLMOPT_PUSHDATA },
			{ "CURLMOPT_PUSHFUNCTION", 21, CURLMOPT_PUSHFUNCTION },
			{ "CURLMOPT_SOCKETDATA", 19, CURLMOPT_SOCKETDATA },
			{ "CURLMOPT_SOCKETFUNCTION", 23, CURLMOPT_SOCKETFUNCTION },
			{ "CURLMOPT_TIMERDATA", 18, CURLMOPT_TIMERDATA },
			{ "CURLMOPT_TIMERFUNCTION", 22, CURLMOPT_TIMERFUNCTION },
			{ "CURLMSG_DONE", 12, CURLMSG_DONE },
			{ "CURLMSG_NONE", 12, CURLMSG_NONE },
			{ "CURLM_ABORTED_BY_CALLBACK", 25, CURLM_ABORTED_BY_CALLBACK },
			{ "CURLM_ADDED_ALREADY", 19, CURLM_ADDED_ALREADY },
			{ "CURLM_BAD_EASY_HANDLE", 21, CURLM_BAD_EASY_HANDLE },
			{ "CURLM_BAD_FUNCTION_ARGUMENT", 27, CURLM_BAD_FUNCTION_ARGUMENT },
			{ "CURLM_BAD_HANDLE", 16, CURLM_BAD_HANDLE },
			{ "CURLM_BAD_SOCKET", 16, CURLM_BAD_SOCKET },
			{ "CURLM_CALL_MULTI_PERFORM", 24, CURLM_CALL_MULTI_PERFORM },
			{ "CURLM_CALL_MULTI_SOCKET", 23, CURLM_CALL_MULTI_SOCKET },
			{ "CURLM_INTERNAL_ERROR", 20, CURLM_INTERNAL_ERROR },
			{ "CURLM_OK", 8, CURLM_OK },
			{ "CURLM_OUT_OF_MEMORY", 19, CURLM_OUT_OF_MEMORY },
			{ "CURLM_RECURSIVE_API_CALL", 24, CURLM_RECURSIVE_API_CALL },
			{ "CURLM_UNKNOWN_OPTION", 20, CURLM_UNKNOWN_OPTION },
			{ "CURLM_UNRECOVERABLE_POLL", 24, CURLM_UNRECOVERABLE_POLL },
			{ "CURLM_WAKEUP_FAILURE", 20, CURLM_WAKEUP_FAILURE },
			{ "CURL_CSELECT_ERR", 16, CURL_CSELECT_ERR },
			{ "CURL_CSELECT_IN", 15, CURL_CSELECT_IN },
			{ "CURL_CSELECT_OUT", 16, CURL_CSELECT_OUT },
			{ "CURL_POLL_IN", 12, CURL_POLL_IN },
			{ "CURL_POLL_INOUT", 15, CURL_POLL_INOUT },
			{ "CURL_POLL_NONE", 14, CURL_POLL_NONE },
			{ "CURL_POLL_OUT", 13, CURL_POLL_OUT },
			{ "CURL_POLL_REMOVE", 16, CURL_POLL_REMOVE },
			{ "CURL_SOCKET_TIMEOUT", 19, CURL_SOCKET_TIMEOUT },
			{ NULL, 0, 0 }
		};
		const struct iv_s *value_for_iv = values_for_iv;
		while ( value_for_iv->name ) {
			perl_curl_constant_add(aTHX_ symbol_table, value_for_iv->name,
				value_for_iv->namelen, newSViv( value_for_iv->value ) );
			++value_for_iv;
		}

		++PL_sub_generation;
	}

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#line 2 "./const-form-xs.inc"
	{
		dTHX;
		HV *symbol_table = get_hv( "Net::Curl::Form::", GV_ADD );
		static const struct iv_s values_for_iv[] = {
			{ "CURLFORM_ARRAY", 14, CURLFORM_ARRAY },
			{ "CURLFORM_BUFFER", 15, CURLFORM_BUFFER },
			{ "CURLFORM_BUFFERLENGTH", 21, CURLFORM_BUFFERLENGTH },
			{ "CURLFORM_BUFFERPTR", 18, CURLFORM_BUFFERPTR },
			{ "CURLFORM_CONTENTHEADER", 22, CURLFORM_CONTENTHEADER },
			{ "CURLFORM_CONTENTLEN", 19, CURLFORM_CONTENTLEN },
			{ "CURLFORM_CONTENTSLENGTH", 23, CURLFORM_CONTENTSLENGTH },
			{ "CURLFORM_CONTENTTYPE", 20, CURLFORM_CONTENTTYPE },
			{ "CURLFORM_COPYCONTENTS", 21, CURLFORM_COPYCONTENTS },
			{ "CURLFORM_COPYNAME", 17, CURLFORM_COPYNAME },
			{ "CURLFORM_END", 12, CURLFORM_END },
			{ "CURLFORM_FILE", 13, CURLFORM_FILE },
			{ "CURLFORM_FILECONTENT", 20, CURLFORM_FILECONTENT },
			{ "CURLFORM_FILENAME", 17, CURLFORM_FILENAME },
			{ "CURLFORM_NAMELENGTH", 19, CURLFORM_NAMELENGTH },
			{ "CURLFORM_NOTHING", 16, CURLFORM_NOTHING },
			{ "CURLFORM_PTRCONTENTS", 20, CURLFORM_PTRCONTENTS },
			{ "CURLFORM_PTRNAME", 16, CURLFORM_PTRNAME },
			{ "CURLFORM_STREAM", 15, CURLFORM_STREAM },
			{ "CURL_FORMADD_DISABLED", 21, CURL_FORMADD_DISABLED },
			{ "CURL_FORMADD_ILLEGAL_ARRAY", 26, CURL_FORMADD_ILLEGAL_ARRAY },
			{ "CURL_FORMADD_INCOMPLETE", 23, CURL_FORMADD_INCOMPLETE },
			{ "CURL_FORMADD_MEMORY", 19, CURL_FORMADD_MEMORY },
			{ "CURL_FORMADD_NULL", 17, CURL_FORMADD_NULL },
			{ "CURL_FORMADD_OK", 15, CURL_FORMADD_OK },
			{ "CURL_FORMADD_OPTION_TWICE", 25, CURL_FORMADD_OPTION_TWICE },
			{ "CURL_FORMADD_UNKNOWN_OPTION", 27, CURL_FORMADD_UNKNOWN_OPTION },
			{ NULL, 0, 0 }
		};
		const struct iv_s *value_for_iv = values_for_iv;
		while ( value_for_iv->name ) {
			perl_curl_constant_add(aTHX_ symbol_table, value_for_iv->name,
				value_for_iv->namelen, newSViv( value_for_iv->value ) );
			++value_for_iv;
		}

		++PL_sub_generation;
	}

#line 2 "./const-easy-xs.inc"
	{
		dTHX;
		HV *symbol_table = get_hv( "Net::Curl::Easy::", GV_ADD );
		static const struct iv_s values_for_iv[] = {
			{ "CURLALTSVC_H1", 13, CURLALTSVC_H1 },
			{ "CURLALTSVC_H2", 13, CURLALTSVC_H2 },
			{ "CURLALTSVC_H3", 13, CURLALTSVC_H3 },
			{ "CURLALTSVC_READONLYFILE", 23, CURLALTSVC_READONLYFILE },
			{ "CURLAUTH_ANY", 12, CURLAUTH_ANY },
			{ "CURLAUTH_ANYSAFE", 16, CURLAUTH_ANYSAFE },
			{ "CURLAUTH_AWS_SIGV4", 18, CURLAUTH_AWS_SIGV4 },
			{ "CURLAUTH_BASIC", 14, CURLAUTH_BASIC },
			{ "CURLAUTH_BEARER", 15, CURLAUTH_BEARER },
			{ "CURLAUTH_DIGEST", 15, CURLAUTH_DIGEST },
			{ "CURLAUTH_DIGEST_IE", 18, CURLAUTH_DIGEST_IE },
			{ "CURLAUTH_GSSAPI", 15, CURLAUTH_GSSAPI },
			{ "CURLAUTH_GSSNEGOTIATE", 21, CURLAUTH_GSSNEGOTIATE },
			{ "CURLAUTH_NEGOTIATE", 18, CURLAUTH_NEGOTIATE },
			{ "CURLAUTH_NONE", 13, CURLAUTH_NONE },
			{ "CURLAUTH_NTLM", 13, CURLAUTH_NTLM },
			{ "CURLAUTH_NTLM_WB", 16, CURLAUTH_NTLM_WB },
			{ "CURLAUTH_ONLY", 13, CURLAUTH_ONLY },
			{ "CURLCLOSEPOLICY_CALLBACK", 24, CURLCLOSEPOLICY_CALLBACK },
			{ "CURLCLOSEPOLICY_LEAST_RECENTLY_USED", 35, CURLCLOSEPOLICY_LEAST_RECENTLY_USED },
			{ "CURLCLOSEPOLICY_LEAST_TRAFFIC", 29, CURLCLOSEPOLICY_LEAST_TRAFFIC },
			{ "CURLCLOSEPOLICY_NONE", 20, CURLCLOSEPOLICY_NONE },
			{ "CURLCLOSEPOLICY_OLDEST", 22, CURLCLOSEPOLICY_OLDEST },
			{ "CURLCLOSEPOLICY_SLOWEST", 23, CURLCLOSEPOLICY_SLOWEST },
			{ "CURLE_ABORTED_BY_CALLBACK", 25, CURLE_ABORTED_BY_CALLBACK },
			{ "CURLE_AGAIN", 11, CURLE_AGAIN },
			{ "CURLE_ALREADY_COMPLETE", 22, CURLE_ALREADY_COMPLETE },
			{ "CURLE_AUTH_ERROR", 16, CURLE_AUTH_ERROR },
			{ "CURLE_BAD_CALLING_ORDER", 23, CURLE_BAD_CALLING_ORDER },
			{ "CURLE_BAD_CONTENT_ENCODING", 26, CURLE_BAD_CONTENT_ENCODING },
			{ "CURLE_BAD_DOWNLOAD_RESUME", 25, CURLE_BAD_DOWNLOAD_RESUME },
			{ "CURLE_BAD_FUNCTION_ARGUMENT", 27, CURLE_BAD_FUNCTION_ARGUMENT },
			{ "CURLE_BAD_PASSWORD_ENTERED", 26, CURLE_BAD_PASSWORD_ENTERED },
			{ "CURLE_CHUNK_FAILED", 18, CURLE_CHUNK_FAILED },
			{ "CURLE_CONV_FAILED", 17, CURLE_CONV_FAILED },
			{ "CURLE_CONV_REQD", 15, CURLE_CONV_REQD },
			{ "CURLE_COULDNT_CONNECT", 21, CURLE_COULDNT_CONNECT },
			{ "CURLE_COULDNT_RESOLVE_HOST", 26, CURLE_COULDNT_RESOLVE_HOST },
			{ "CURLE_COULDNT_RESOLVE_PROXY", 27, CURLE_COULDNT_RESOLVE_PROXY },
			{ "CURLE_ECH_REQUIRED", 18, CURLE_ECH_REQUIRED },
			{ "CURLE_FAILED_INIT", 17, CURLE_FAILED_INIT },
			{ "CURLE_FILESIZE_EXCEEDED", 23, CURLE_FILESIZE_EXCEEDED },
			{ "CURLE_FILE_COULDNT_READ_FILE", 28, CURLE_FILE_COULDNT_READ_FILE },
			{ "CURLE_FTP_ACCEPT_FAILED", 23, CURLE_FTP_ACCEPT_FAILED },
			{ "CURLE_FTP_ACCEPT_TIMEOUT", 24, CURLE_FTP_ACCEPT_TIMEOUT },
			{ "CURLE_FTP_ACCESS_DENIED", 23, CURLE_FTP_ACCESS_DENIED },
			{ "CURLE_FTP_BAD_DOWNLOAD_RESUME", 29, CURLE_FTP_BAD_DOWNLOAD_RESUME },
			{ "CURLE_FTP_BAD_FILE_LIST", 23, CURLE_FTP_BAD_FILE_LIST },
			{ "CURLE_FTP_CANT_GET_HOST", 23, CURLE_FTP_CANT_GET_HOST },
			{ "CURLE_FTP_CANT_RECONNECT", 24, CURLE_FTP_CANT_RECONNECT },
			{ "CURLE_FTP_COULDNT_GET_SIZE", 26, CURLE_FTP_COULDNT_GET_SIZE },
			{ "CURLE_FTP_COULDNT_RETR_FILE", 27, CURLE_FTP_COULDNT_RETR_FILE },
			{ "CURLE_FTP_COULDNT_SET_ASCII", 27, CURLE_FTP_COULDNT_SET_ASCII },
			{ "CURLE_FTP_COULDNT_SET_BINARY", 28, CURLE_FTP_COULDNT_SET_BINARY },
			{ "CURLE_FTP_COULDNT_SET_TYPE", 26, CURLE_FTP_COULDNT_SET_TYPE },
			{ "CURLE_FTP_COULDNT_STOR_FILE", 27, CURLE_FTP_COULDNT_STOR_FILE },
			{ "CURLE_FTP_COULDNT_USE_REST", 26, CURLE_FTP_COULDNT_USE_REST },
			{ "CURLE_FTP_PARTIAL_FILE", 22, CURLE_FTP_PARTIAL_FILE },
			{ "CURLE_FTP_PORT_FAILED", 21, CURLE_FTP_PORT_FAILED },
			{ "CURLE_FTP_PRET_FAILED", 21, CURLE_FTP_PRET_FAILED },
			{ "CURLE_FTP_QUOTE_ERROR", 21, CURLE_FTP_QUOTE_ERROR },
			{ "CURLE_FTP_SSL_FAILED", 20, CURLE_FTP_SSL_FAILED },
			{ "CURLE_FTP_USER_PASSWORD_INCORRECT", 33, CURLE_FTP_USER_PASSWORD_INCORRECT },
			{ "CURLE_FTP_WEIRD_227_FORMAT", 26, CURLE_FTP_WEIRD_227_FORMAT },
			{ "CURLE_FTP_WEIRD_PASS_REPLY", 26, CURLE_FTP_WEIRD_PASS_REPLY },
			{ "CURLE_FTP_WEIRD_PASV_REPLY", 26, CURLE_FTP_WEIRD_PASV_REPLY },
			{ "CURLE_FTP_WEIRD_SERVER_REPLY", 28, CURLE_FTP_WEIRD_SERVER_REPLY },
			{ "CURLE_FTP_WEIRD_USER_REPLY", 26, CURLE_FTP_WEIRD_USER_REPLY },
			{ "CURLE_FTP_WRITE_ERROR", 21, CURLE_FTP_WRITE_ERROR },
			{ "CURLE_FUNCTION_NOT_FOUND", 24, CURLE_FUNCTION_NOT_FOUND },
			{ "CURLE_GOT_NOTHING", 17, CURLE_GOT_NOTHING },
			{ "CURLE_HTTP2", 11, CURLE_HTTP2 },
			{ "CURLE_HTTP2_STREAM", 18, CURLE_HTTP2_STREAM },
			{ "CURLE_HTTP3", 11, CURLE_HTTP3 },
			{ "CURLE_HTTP_NOT_FOUND", 20, CURLE_HTTP_NOT_FOUND },
			{ "CURLE_HTTP_PORT_FAILED", 22, CURLE_HTTP_PORT_FAILED },
			{ "CURLE_HTTP_POST_ERROR", 21, CURLE_HTTP_POST_ERROR },
			{ "CURLE_HTTP_RANGE_ERROR", 22, CURLE_HTTP_RANGE_ERROR },
			{ "CURLE_HTTP_RETURNED_ERROR", 25, CURLE_HTTP_RETURNED_ERROR },
			{ "CURLE_INTERFACE_FAILED", 22, CURLE_INTERFACE_FAILED },
			{ "CURLE_LDAP_CANNOT_BIND", 22, CURLE_LDAP_CANNOT_BIND },
			{ "CURLE_LDAP_INVALID_URL", 22, CURLE_LDAP_INVALID_URL },
			{ "CURLE_LDAP_SEARCH_FAILED", 24, CURLE_LDAP_SEARCH_FAILED },
			{ "CURLE_LIBRARY_NOT_FOUND", 23, CURLE_LIBRARY_NOT_FOUND },
			{ "CURLE_LOGIN_DENIED", 18, CURLE_LOGIN_DENIED },
			{ "CURLE_MALFORMAT_USER", 20, CURLE_MALFORMAT_USER },
			{ "CURLE_NOT_BUILT_IN", 18, CURLE_NOT_BUILT_IN },
			{ "CURLE_NO_CONNECTION_AVAILABLE", 29, CURLE_NO_CONNECTION_AVAILABLE },
			{ "CURLE_OK", 8, CURLE_OK },
			{ "CURLE_OPERATION_TIMEDOUT", 24, CURLE_OPERATION_TIMEDOUT },
			{ "CURLE_OPERATION_TIMEOUTED", 25, CURLE_OPERATION_TIMEOUTED },
			{ "CURLE_OUT_OF_MEMORY", 19, CURLE_OUT_OF_MEMORY },
			{ "CURLE_PARTIAL_FILE", 18, CURLE_PARTIAL_FILE },
			{ "CURLE_PEER_FAILED_VERIFICATION", 30, CURLE_PEER_FAILED_VERIFICATION },
			{ "CURLE_PROXY", 11, CURLE_PROXY },
			{ "CURLE_QUIC_CONNECT_ERROR", 24, CURLE_QUIC_CONNECT_ERROR },
			{ "CURLE_QUOTE_ERROR", 17, CURLE_QUOTE_ERROR },
			{ "CURLE_RANGE_ERROR", 17, CURLE_RANGE_ERROR },
			{ "CURLE_READ_ERROR", 16, CURLE_READ_ERROR },
			{ "CURLE_RECURSIVE_API_CALL", 24, CURLE_RECURSIVE_API_CALL },
			{ "CURLE_RECV_ERROR", 16, CURLE_RECV_ERROR },
			{ "CURLE_REMOTE_ACCESS_DENIED", 26, CURLE_REMOTE_ACCESS_DENIED },
			{ "CURLE_REMOTE_DISK_FULL", 22, CURLE_REMOTE_DISK_FULL },
			{ "CURLE_REMOTE_FILE_EXISTS", 24, CURLE_REMOTE_FILE_EXISTS },
			{ "CURLE_REMOTE_FILE_NOT_FOUND", 27, CURLE_REMOTE_FILE_NOT_FOUND },
			{ "CURLE_RTSP_CSEQ_ERROR", 21, CURLE_RTSP_CSEQ_ERROR },
			{ "CURLE_RTSP_SESSION_ERROR", 24, CURLE_RTSP_SESSION_ERROR },
			{ "CURLE_SEND_ERROR", 16, CURLE_SEND_ERROR },
			{ "CURLE_SEND_FAIL_REWIND", 22, CURLE_SEND_FAIL_REWIND },
			{ "CURLE_SETOPT_OPTION_SYNTAX", 26, CURLE_SETOPT_OPTION_SYNTAX },
			{ "CURLE_SHARE_IN_USE", 18, CURLE_SHARE_IN_USE },
			{ "CURLE_SSH", 9, CURLE_SSH },
			{ "CURLE_SSL_CACERT", 16, CURLE_SSL_CACERT },
			{ "CURLE_SSL_CACERT_BADFILE", 24, CURLE_SSL_CACERT_BADFILE },
			{ "CURLE_SSL_CERTPROBLEM", 21, CURLE_SSL_CERTPROBLEM },
			{ "CURLE_SSL_CIPHER", 16, CURLE_SSL_CIPHER },
			{ "CURLE_SSL_CLIENTCERT", 20, CURLE_SSL_CLIENTCERT },
			{ "CURLE_SSL_CONNECT_ERROR", 23, CURLE_SSL_CONNECT_ERROR },
			{ "CURLE_SSL_CRL_BADFILE", 21, CURLE_SSL_CRL_BADFILE },
			{ "CURLE_SSL_ENGINE_INITFAILED", 27, CURLE_SSL_ENGINE_INITFAILED },
			{ "CURLE_SSL_ENGINE_NOTFOUND", 25, CURLE_SSL_ENGINE_NOTFOUND },
			{ "CURLE_SSL_ENGINE_SETFAILED", 26, CURLE_SSL_ENGINE_SETFAILED },
			{ "CURLE_SSL_INVALIDCERTSTATUS", 27, CURLE_SSL_INVALIDCERTSTATUS },
			{ "CURLE_SSL_ISSUER_ERROR", 22, CURLE_SSL_ISSUER_ERROR },
			{ "CURLE_SSL_PEER_CERTIFICATE", 26, CURLE_SSL_PEER_CERTIFICATE },
			{ "CURLE_SSL_PINNEDPUBKEYNOTMATCH", 30, CURLE_SSL_PINNEDPUBKEYNOTMATCH },
			{ "CURLE_SSL_SHUTDOWN_FAILED", 25, CURLE_SSL_SHUTDOWN_FAILED },
			{ "CURLE_TELNET_OPTION_SYNTAX", 26, CURLE_TELNET_OPTION_SYNTAX },
			{ "CURLE_TFTP_DISKFULL", 19, CURLE_TFTP_DISKFULL },
			{ "CURLE_TFTP_EXISTS", 17, CURLE_TFTP_EXISTS },
			{ "CURLE_TFTP_ILLEGAL", 18, CURLE_TFTP_ILLEGAL },
			{ "CURLE_TFTP_NOSUCHUSER", 21, CURLE_TFTP_NOSUCHUSER },
			{ "CURLE_TFTP_NOTFOUND", 19, CURLE_TFTP_NOTFOUND },
			{ "CURLE_TFTP_PERM", 15, CURLE_TFTP_PERM },
			{ "CURLE_TFTP_UNKNOWNID", 20, CURLE_TFTP_UNKNOWNID },
			{ "CURLE_TOO_LARGE", 15, CURLE_TOO_LARGE },
			{ "CURLE_TOO_MANY_REDIRECTS", 24, CURLE_TOO_MANY_REDIRECTS },
			{ "CURLE_UNKNOWN_OPTION", 20, CURLE_UNKNOWN_OPTION },
			{ "CURLE_UNKNOWN_TELNET_OPTION", 27, CURLE_UNKNOWN_TELNET_OPTION },
			{ "CURLE_UNRECOVERABLE_POLL", 24, CURLE_UNRECOVERABLE_POLL },
			{ "CURLE_UNSUPPORTED_PROTOCOL", 26, CURLE_UNSUPPORTED_PROTOCOL },
			{ "CURLE_UPLOAD_FAILED", 19, CURLE_UPLOAD_FAILED },
			{ "CURLE_URL_MALFORMAT", 19, CURLE_URL_MALFORMAT },
			{ "CURLE_URL_MALFORMAT_USER", 24, CURLE_URL_MALFORMAT_USER },
			{ "CURLE_USE_SSL_FAILED", 20, CURLE_USE_SSL_FAILED },
			{ "CURLE_WEIRD_SERVER_REPLY", 24, CURLE_WEIRD_SERVER_REPLY },
			{ "CURLE_WRITE_ERROR", 17, CURLE_WRITE_ERROR },
			{ "CURLFILETYPE_DEVICE_BLOCK", 25, CURLFILETYPE_DEVICE_BLOCK },
			{ "CURLFILETYPE_DEVICE_CHAR", 24, CURLFILETYPE_DEVICE_CHAR },
			{ "CURLFILETYPE_DIRECTORY", 22, CURLFILETYPE_DIRECTORY },
			{ "CURLFILETYPE_DOOR", 17, CURLFILETYPE_DOOR },
			{ "CURLFILETYPE_FILE", 17, CURLFILETYPE_FILE },
			{ "CURLFILETYPE_NAMEDPIPE", 22, CURLFILETYPE_NAMEDPIPE },
			{ "CURLFILETYPE_SOCKET", 19, CURLFILETYPE_SOCKET },
			{ "CURLFILETYPE_SYMLINK", 20, CURLFILETYPE_SYMLINK },
			{ "CURLFILETYPE_UNKNOWN", 20, CURLFILETYPE_UNKNOWN },
			{ "CURLFINFOFLAG_KNOWN_FILENAME", 28, CURLFINFOFLAG_KNOWN_FILENAME },
			{ "CURLFINFOFLAG_KNOWN_FILETYPE", 28, CURLFINFOFLAG_KNOWN_FILETYPE },
			{ "CURLFINFOFLAG_KNOWN_GID", 23, CURLFINFOFLAG_KNOWN_GID },
			{ "CURLFINFOFLAG_KNOWN_HLINKCOUNT", 30, CURLFINFOFLAG_KNOWN_HLINKCOUNT },
			{ "CURLFINFOFLAG_KNOWN_PERM", 24, CURLFINFOFLAG_KNOWN_PERM },
			{ "CURLFINFOFLAG_KNOWN_SIZE", 24, CURLFINFOFLAG_KNOWN_SIZE },
			{ "CURLFINFOFLAG_KNOWN_TIME", 24, CURLFINFOFLAG_KNOWN_TIME },
			{ "CURLFINFOFLAG_KNOWN_UID", 23, CURLFINFOFLAG_KNOWN_UID },
			{ "CURLFTPAUTH_DEFAULT", 19, CURLFTPAUTH_DEFAULT },
			{ "CURLFTPAUTH_SSL", 15, CURLFTPAUTH_SSL },
			{ "CURLFTPAUTH_TLS", 15, CURLFTPAUTH_TLS },
			{ "CURLFTPMETHOD_DEFAULT", 21, CURLFTPMETHOD_DEFAULT },
			{ "CURLFTPMETHOD_MULTICWD", 22, CURLFTPMETHOD_MULTICWD },
			{ "CURLFTPMETHOD_NOCWD", 19, CURLFTPMETHOD_NOCWD },
			{ "CURLFTPMETHOD_SINGLECWD", 23, CURLFTPMETHOD_SINGLECWD },
			{ "CURLFTPSSL_ALL", 14, CURLFTPSSL_ALL },
			{ "CURLFTPSSL_CCC_ACTIVE", 21, CURLFTPSSL_CCC_ACTIVE },
			{ "CURLFTPSSL_CCC_NONE", 19, CURLFTPSSL_CCC_NONE },
			{ "CURLFTPSSL_CCC_PASSIVE", 22, CURLFTPSSL_CCC_PASSIVE },
			{ "CURLFTPSSL_CONTROL", 18, CURLFTPSSL_CONTROL },
			{ "CURLFTPSSL_NONE", 15, CURLFTPSSL_NONE },
			{ "CURLFTPSSL_TRY", 14, CURLFTPSSL_TRY },
			{ "CURLFTP_CREATE_DIR", 18, CURLFTP_CREATE_DIR },
			{ "CURLFTP_CREATE_DIR_NONE", 23, CURLFTP_CREATE_DIR_NONE },
			{ "CURLFTP_CREATE_DIR_RETRY", 24, CURLFTP_CREATE_DIR_RETRY },
			{ "CURLGSSAPI_DELEGATION_FLAG", 26, CURLGSSAPI_DELEGATION_FLAG },
			{ "CURLGSSAPI_DELEGATION_NONE", 26, CURLGSSAPI_DELEGATION_NONE },
			{ "CURLGSSAPI_DELEGATION_POLICY_FLAG", 33, CURLGSSAPI_DELEGATION_POLICY_FLAG },
			{ "CURLHEADER_SEPARATE", 19, CURLHEADER_SEPARATE },
			{ "CURLHEADER_UNIFIED", 18, CURLHEADER_UNIFIED },
			{ "CURLHE_BADINDEX", 15, CURLHE_BADINDEX },
			{ "CURLHE_BAD_ARGUMENT", 19, CURLHE_BAD_ARGUMENT },
			{ "CURLHE_MISSING", 14, CURLHE_MISSING },
			{ "CURLHE_NOHEADERS", 16, CURLHE_NOHEADERS },
			{ "CURLHE_NOREQUEST", 16, CURLHE_NOREQUEST },
			{ "CURLHE_NOT_BUILT_IN", 19, CURLHE_NOT_BUILT_IN },
			{ "CURLHE_OK", 9, CURLHE_OK },
			{ "CURLHE_OUT_OF_MEMORY", 20, CURLHE_OUT_OF_MEMORY },
			{ "CURLHSTS_ENABLE", 15, CURLHSTS_ENABLE },
			{ "CURLHSTS_READONLYFILE", 21, CURLHSTS_READONLYFILE },
			{ "CURLINFO_ACTIVESOCKET", 21, CURLINFO_ACTIVESOCKET },
			{ "CURLINFO_APPCONNECT_TIME", 24, CURLINFO_APPCONNECT_TIME },
			{ "CURLINFO_APPCONNECT_TIME_T", 26, CURLINFO_APPCONNECT_TIME_T },
			{ "CURLINFO_CAINFO", 15, CURLINFO_CAINFO },
			{ "CURLINFO_CAPATH", 15, CURLINFO_CAPATH },
			{ "CURLINFO_CERTINFO", 17, CURLINFO_CERTINFO },
			{ "CURLINFO_CONDITION_UNMET", 24, CURLINFO_CONDITION_UNMET },
			{ "CURLINFO_CONNECT_TIME", 21, CURLINFO_CONNECT_TIME },
			{ "CURLINFO_CONNECT_TIME_T", 23, CURLINFO_CONNECT_TIME_T },
			{ "CURLINFO_CONN_ID", 16, CURLINFO_CONN_ID },
			{ "CURLINFO_CONTENT_LENGTH_DOWNLOAD", 32, CURLINFO_CONTENT_LENGTH_DOWNLOAD },
			{ "CURLINFO_CONTENT_LENGTH_DOWNLOAD_T", 34, CURLINFO_CONTENT_LENGTH_DOWNLOAD_T },
			{ "CURLINFO_CONTENT_LENGTH_UPLOAD", 30, CURLINFO_CONTENT_LENGTH_UPLOAD },
			{ "CURLINFO_CONTENT_LENGTH_UPLOAD_T", 32, CURLINFO_CONTENT_LENGTH_UPLOAD_T },
			{ "CURLINFO_CONTENT_TYPE", 21, CURLINFO_CONTENT_TYPE },
			{ "CURLINFO_COOKIELIST", 19, CURLINFO_COOKIELIST },
			{ "CURLINFO_DATA_IN", 16, CURLINFO_DATA_IN },
			{ "CURLINFO_DATA_OUT", 17, CURLINFO_DATA_OUT },
			{ "CURLINFO_DOUBLE", 15, CURLINFO_DOUBLE },
			{ "CURLINFO_EARLYDATA_SENT_T", 25, CURLINFO_EARLYDATA_SENT_T },
			{ "CURLINFO_EFFECTIVE_METHOD", 25, CURLINFO_EFFECTIVE_METHOD },
			{ "CURLINFO_EFFECTIVE_URL", 22, CURLINFO_EFFECTIVE_URL },
			{ "CURLINFO_END", 12, CURLINFO_END },
			{ "CURLINFO_FILETIME", 17, CURLINFO_FILETIME },
			{ "CURLINFO_FILETIME_T", 19, CURLINFO_FILETIME_T },
			{ "CURLINFO_FTP_ENTRY_PATH", 23, CURLINFO_FTP_ENTRY_PATH },
			{ "CURLINFO_HEADER_IN", 18, CURLINFO_HEADER_IN },
			{ "CURLINFO_HEADER_OUT", 19, CURLINFO_HEADER_OUT },
			{ "CURLINFO_HEADER_SIZE", 20, CURLINFO_HEADER_SIZE },
			{ "CURLINFO_HTTPAUTH_AVAIL", 23, CURLINFO_HTTPAUTH_AVAIL },
			{ "CURLINFO_HTTP_CODE", 18, CURLINFO_HTTP_CODE },
			{ "CURLINFO_HTTP_CONNECTCODE", 25, CURLINFO_HTTP_CONNECTCODE },
			{ "CURLINFO_HTTP_VERSION", 21, CURLINFO_HTTP_VERSION },
			{ "CURLINFO_LASTONE", 16, CURLINFO_LASTONE },
			{ "CURLINFO_LASTSOCKET", 19, CURLINFO_LASTSOCKET },
			{ "CURLINFO_LOCAL_IP", 17, CURLINFO_LOCAL_IP },
			{ "CURLINFO_LOCAL_PORT", 19, CURLINFO_LOCAL_PORT },
			{ "CURLINFO_LONG", 13, CURLINFO_LONG },
			{ "CURLINFO_MASK", 13, CURLINFO_MASK },
			{ "CURLINFO_NAMELOOKUP_TIME", 24, CURLINFO_NAMELOOKUP_TIME },
			{ "CURLINFO_NAMELOOKUP_TIME_T", 26, CURLINFO_NAMELOOKUP_TIME_T },
			{ "CURLINFO_NONE", 13, CURLINFO_NONE },
			{ "CURLINFO_NUM_CONNECTS", 21, CURLINFO_NUM_CONNECTS },
			{ "CURLINFO_OFF_T", 14, CURLINFO_OFF_T },
			{ "CURLINFO_OS_ERRNO", 17, CURLINFO_OS_ERRNO },
			{ "CURLINFO_POSTTRANSFER_TIME_T", 28, CURLINFO_POSTTRANSFER_TIME_T },
			{ "CURLINFO_PRETRANSFER_TIME", 25, CURLINFO_PRETRANSFER_TIME },
			{ "CURLINFO_PRETRANSFER_TIME_T", 27, CURLINFO_PRETRANSFER_TIME_T },
			{ "CURLINFO_PRIMARY_IP", 19, CURLINFO_PRIMARY_IP },
			{ "CURLINFO_PRIMARY_PORT", 21, CURLINFO_PRIMARY_PORT },
			{ "CURLINFO_PRIVATE", 16, CURLINFO_PRIVATE },
			{ "CURLINFO_PROTOCOL", 17, CURLINFO_PROTOCOL },
			{ "CURLINFO_PROXYAUTH_AVAIL", 24, CURLINFO_PROXYAUTH_AVAIL },
			{ "CURLINFO_PROXY_ERROR", 20, CURLINFO_PROXY_ERROR },
			{ "CURLINFO_PROXY_SSL_VERIFYRESULT", 31, CURLINFO_PROXY_SSL_VERIFYRESULT },
			{ "CURLINFO_PTR", 12, CURLINFO_PTR },
			{ "CURLINFO_QUEUE_TIME_T", 21, CURLINFO_QUEUE_TIME_T },
			{ "CURLINFO_REDIRECT_COUNT", 23, CURLINFO_REDIRECT_COUNT },
			{ "CURLINFO_REDIRECT_TIME", 22, CURLINFO_REDIRECT_TIME },
			{ "CURLINFO_REDIRECT_TIME_T", 24, CURLINFO_REDIRECT_TIME_T },
			{ "CURLINFO_REDIRECT_URL", 21, CURLINFO_REDIRECT_URL },
			{ "CURLINFO_REFERER", 16, CURLINFO_REFERER },
			{ "CURLINFO_REQUEST_SIZE", 21, CURLINFO_REQUEST_SIZE },
			{ "CURLINFO_RESPONSE_CODE", 22, CURLINFO_RESPONSE_CODE },
			{ "CURLINFO_RETRY_AFTER", 20, CURLINFO_RETRY_AFTER },
			{ "CURLINFO_RTSP_CLIENT_CSEQ", 25, CURLINFO_RTSP_CLIENT_CSEQ },
			{ "CURLINFO_RTSP_CSEQ_RECV", 23, CURLINFO_RTSP_CSEQ_RECV },
			{ "CURLINFO_RTSP_SERVER_CSEQ", 25, CURLINFO_RTSP_SERVER_CSEQ },
			{ "CURLINFO_RTSP_SESSION_ID", 24, CURLINFO_RTSP_SESSION_ID },
			{ "CURLINFO_SCHEME", 15, CURLINFO_SCHEME },
			{ "CURLINFO_SIZE_DOWNLOAD", 22, CURLINFO_SIZE_DOWNLOAD },
			{ "CURLINFO_SIZE_DOWNLOAD_T", 24, CURLINFO_SIZE_DOWNLOAD_T },
			{ "CURLINFO_SIZE_UPLOAD", 20, CURLINFO_SIZE_UPLOAD },
			{ "CURLINFO_SIZE_UPLOAD_T", 22, CURLINFO_SIZE_UPLOAD_T },
			{ "CURLINFO_SLIST", 14, CURLINFO_SLIST },
			{ "CURLINFO_SOCKET", 15, CURLINFO_SOCKET },
			{ "CURLINFO_SPEED_DOWNLOAD", 23, CURLINFO_SPEED_DOWNLOAD },
			{ "CURLINFO_SPEED_DOWNLOAD_T", 25, CURLINFO_SPEED_DOWNLOAD_T },
			{ "CURLINFO_SPEED_UPLOAD", 21, CURLINFO_SPEED_UPLOAD },
			{ "CURLINFO_SPEED_UPLOAD_T", 23, CURLINFO_SPEED_UPLOAD_T },
			{ "CURLINFO_SSL_DATA_IN", 20, CURLINFO_SSL_DATA_IN },
			{ "CURLINFO_SSL_DATA_OUT", 21, CURLINFO_SSL_DATA_OUT },
			{ "CURLINFO_SSL_ENGINES", 20, CURLINFO_SSL_ENGINES },
			{ "CURLINFO_SSL_VERIFYRESULT", 25, CURLINFO_SSL_VERIFYRESULT },
			{ "CURLINFO_STARTTRANSFER_TIME", 27, CURLINFO_STARTTRANSFER_TIME },
			{ "CURLINFO_STARTTRANSFER_TIME_T", 29, CURLINFO_STARTTRANSFER_TIME_T },
			{ "CURLINFO_STRING", 15, CURLINFO_STRING },
			{ "CURLINFO_TEXT", 13, CURLINFO_TEXT },
			{ "CURLINFO_TLS_SESSION", 20, CURLINFO_TLS_SESSION },
			{ "CURLINFO_TLS_SSL_PTR", 20, CURLINFO_TLS_SSL_PTR },
			{ "CURLINFO_TOTAL_TIME", 19, CURLINFO_TOTAL_TIME },
			{ "CURLINFO_TOTAL_TIME_T", 21, CURLINFO_TOTAL_TIME_T },
			{ "CURLINFO_TYPEMASK", 17, CURLINFO_TYPEMASK },
			{ "CURLINFO_USED_PROXY", 19, CURLINFO_USED_PROXY },
			{ "CURLINFO_XFER_ID", 16, CURLINFO_XFER_ID },
			{ "CURLIOCMD_NOP", 13, CURLIOCMD_NOP },
			{ "CURLIOCMD_RESTARTREAD", 21, CURLIOCMD_RESTARTREAD },
			{ "CURLIOE_FAILRESTART", 19, CURLIOE_FAILRESTART },
			{ "CURLIOE_OK", 10, CURLIOE_OK },
			{ "CURLIOE_UNKNOWNCMD", 18, CURLIOE_UNKNOWNCMD },
			{ "CURLKHMATCH_MISMATCH", 20, CURLKHMATCH_MISMATCH },
			{ "CURLKHMATCH_MISSING", 19, CURLKHMATCH_MISSING },
			{ "CURLKHMATCH_OK", 14, CURLKHMATCH_OK },
			{ "CURLKHSTAT_DEFER", 16, CURLKHSTAT_DEFER },
			{ "CURLKHSTAT_FINE", 15, CURLKHSTAT_FINE },
			{ "CURLKHSTAT_FINE_ADD_TO_FILE", 27, CURLKHSTAT_FINE_ADD_TO_FILE },
			{ "CURLKHSTAT_FINE_REPLACE", 23, CURLKHSTAT_FINE_REPLACE },
			{ "CURLKHSTAT_REJECT", 17, CURLKHSTAT_REJECT },
			{ "CURLKHTYPE_DSS", 14, CURLKHTYPE_DSS },
			{ "CURLKHTYPE_ECDSA", 16, CURLKHTYPE_ECDSA },
			{ "CURLKHTYPE_ED25519", 18, CURLKHTYPE_ED25519 },
			{ "CURLKHTYPE_RSA", 14, CURLKHTYPE_RSA },
			{ "CURLKHTYPE_RSA1", 15, CURLKHTYPE_RSA1 },
			{ "CURLKHTYPE_UNKNOWN", 18, CURLKHTYPE_UNKNOWN },
			{ "CURLMIMEOPT_FORMESCAPE", 22, CURLMIMEOPT_FORMESCAPE },
			{ "CURLOPTTYPE_BLOB", 16, CURLOPTTYPE_BLOB },
			{ "CURLOPTTYPE_CBPOINT", 19, CURLOPTTYPE_CBPOINT },
			{ "CURLOPTTYPE_FUNCTIONPOINT", 25, CURLOPTTYPE_FUNCTIONPOINT },
			{ "CURLOPTTYPE_LONG", 16, CURLOPTTYPE_LONG },
			{ "CURLOPTTYPE_OBJECTPOINT", 23, CURLOPTTYPE_OBJECTPOINT },
			{ "CURLOPTTYPE_OFF_T", 17, CURLOPTTYPE_OFF_T },
			{ "CURLOPTTYPE_SLISTPOINT", 22, CURLOPTTYPE_SLISTPOINT },
			{ "CURLOPTTYPE_STRINGPOINT", 23, CURLOPTTYPE_STRINGPOINT },
			{ "CURLOPTTYPE_VALUES", 18, CURLOPTTYPE_VALUES },
			{ "CURLOPT_ABSTRACT_UNIX_SOCKET", 28, CURLOPT_ABSTRACT_UNIX_SOCKET },
			{ "CURLOPT_ACCEPTTIMEOUT_MS", 24, CURLOPT_ACCEPTTIMEOUT_MS },
			{ "CURLOPT_ACCEPT_ENCODING", 23, CURLOPT_ACCEPT_ENCODING },
			{ "CURLOPT_ADDRESS_SCOPE", 21, CURLOPT_ADDRESS_SCOPE },
			{ "CURLOPT_ALTSVC", 14, CURLOPT_ALTSVC },
			{ "CURLOPT_ALTSVC_CTRL", 19, CURLOPT_ALTSVC_CTRL },
			{ "CURLOPT_APPEND", 14, CURLOPT_APPEND },
			{ "CURLOPT_AUTOREFERER", 19, CURLOPT_AUTOREFERER },
			{ "CURLOPT_AWS_SIGV4", 17, CURLOPT_AWS_SIGV4 },
			{ "CURLOPT_BUFFERSIZE", 18, CURLOPT_BUFFERSIZE },
			{ "CURLOPT_CAINFO", 14, CURLOPT_CAINFO },
			{ "CURLOPT_CAINFO_BLOB", 19, CURLOPT_CAINFO_BLOB },
			{ "CURLOPT_CAPATH", 14, CURLOPT_CAPATH },
			{ "CURLOPT_CA_CACHE_TIMEOUT", 24, CURLOPT_CA_CACHE_TIMEOUT },
			{ "CURLOPT_CERTINFO", 16, CURLOPT_CERTINFO },
			{ "CURLOPT_CHUNK_BGN_FUNCTION", 26, CURLOPT_CHUNK_BGN_FUNCTION },
			{ "CURLOPT_CHUNK_DATA", 18, CURLOPT_CHUNK_DATA },
			{ "CURLOPT_CHUNK_END_FUNCTION", 26, CURLOPT_CHUNK_END_FUNCTION },
			{ "CURLOPT_CLOSEPOLICY", 19, CURLOPT_CLOSEPOLICY },
			{ "CURLOPT_CLOSESOCKETDATA", 23, CURLOPT_CLOSESOCKETDATA },
			{ "CURLOPT_CLOSESOCKETFUNCTION", 27, CURLOPT_CLOSESOCKETFUNCTION },
			{ "CURLOPT_CONNECTTIMEOUT", 22, CURLOPT_CONNECTTIMEOUT },
			{ "CURLOPT_CONNECTTIMEOUT_MS", 25, CURLOPT_CONNECTTIMEOUT_MS },
			{ "CURLOPT_CONNECT_ONLY", 20, CURLOPT_CONNECT_ONLY },
			{ "CURLOPT_CONNECT_TO", 18, CURLOPT_CONNECT_TO },
			{ "CURLOPT_CONV_FROM_NETWORK_FUNCTION", 34, CURLOPT_CONV_FROM_NETWORK_FUNCTION },
			{ "CURLOPT_CONV_FROM_UTF8_FUNCTION", 31, CURLOPT_CONV_FROM_UTF8_FUNCTION },
			{ "CURLOPT_CONV_TO_NETWORK_FUNCTION", 32, CURLOPT_CONV_TO_NETWORK_FUNCTION },
			{ "CURLOPT_COOKIE", 14, CURLOPT_COOKIE },
			{ "CURLOPT_COOKIEFILE", 18, CURLOPT_COOKIEFILE },
			{ "CURLOPT_COOKIEJAR", 17, CURLOPT_COOKIEJAR },
			{ "CURLOPT_COOKIELIST", 18, CURLOPT_COOKIELIST },
			{ "CURLOPT_COOKIESESSION", 21, CURLOPT_COOKIESESSION },
			{ "CURLOPT_COPYPOSTFIELDS", 22, CURLOPT_COPYPOSTFIELDS },
			{ "CURLOPT_CRLF", 12, CURLOPT_CRLF },
			{ "CURLOPT_CRLFILE", 15, CURLOPT_CRLFILE },
			{ "CURLOPT_CURLU", 13, CURLOPT_CURLU },
			{ "CURLOPT_CUSTOMREQUEST", 21, CURLOPT_CUSTOMREQUEST },
			{ "CURLOPT_DEBUGDATA", 17, CURLOPT_DEBUGDATA },
			{ "CURLOPT_DEBUGFUNCTION", 21, CURLOPT_DEBUGFUNCTION },
			{ "CURLOPT_DEFAULT_PROTOCOL", 24, CURLOPT_DEFAULT_PROTOCOL },
			{ "CURLOPT_DIRLISTONLY", 19, CURLOPT_DIRLISTONLY },
			{ "CURLOPT_DISALLOW_USERNAME_IN_URL", 32, CURLOPT_DISALLOW_USERNAME_IN_URL },
			{ "CURLOPT_DNS_CACHE_TIMEOUT", 25, CURLOPT_DNS_CACHE_TIMEOUT },
			{ "CURLOPT_DNS_INTERFACE", 21, CURLOPT_DNS_INTERFACE },
			{ "CURLOPT_DNS_LOCAL_IP4", 21, CURLOPT_DNS_LOCAL_IP4 },
			{ "CURLOPT_DNS_LOCAL_IP6", 21, CURLOPT_DNS_LOCAL_IP6 },
			{ "CURLOPT_DNS_SERVERS", 19, CURLOPT_DNS_SERVERS },
			{ "CURLOPT_DNS_SHUFFLE_ADDRESSES", 29, CURLOPT_DNS_SHUFFLE_ADDRESSES },
			{ "CURLOPT_DNS_USE_GLOBAL_CACHE", 28, CURLOPT_DNS_USE_GLOBAL_CACHE },
			{ "CURLOPT_DOH_SSL_VERIFYHOST", 26, CURLOPT_DOH_SSL_VERIFYHOST },
			{ "CURLOPT_DOH_SSL_VERIFYPEER", 26, CURLOPT_DOH_SSL_VERIFYPEER },
			{ "CURLOPT_DOH_SSL_VERIFYSTATUS", 28, CURLOPT_DOH_SSL_VERIFYSTATUS },
			{ "CURLOPT_DOH_URL", 15, CURLOPT_DOH_URL },
			{ "CURLOPT_ECH", 11, CURLOPT_ECH },
			{ "CURLOPT_EGDSOCKET", 17, CURLOPT_EGDSOCKET },
			{ "CURLOPT_ENCODING", 16, CURLOPT_ENCODING },
			{ "CURLOPT_ERRORBUFFER", 19, CURLOPT_ERRORBUFFER },
			{ "CURLOPT_EXPECT_100_TIMEOUT_MS", 29, CURLOPT_EXPECT_100_TIMEOUT_MS },
			{ "CURLOPT_FAILONERROR", 19, CURLOPT_FAILONERROR },
			{ "CURLOPT_FILE", 12, CURLOPT_FILE },
			{ "CURLOPT_FILETIME", 16, CURLOPT_FILETIME },
			{ "CURLOPT_FNMATCH_DATA", 20, CURLOPT_FNMATCH_DATA },
			{ "CURLOPT_FNMATCH_FUNCTION", 24, CURLOPT_FNMATCH_FUNCTION },
			{ "CURLOPT_FOLLOWLOCATION", 22, CURLOPT_FOLLOWLOCATION },
			{ "CURLOPT_FORBID_REUSE", 20, CURLOPT_FORBID_REUSE },
			{ "CURLOPT_FRESH_CONNECT", 21, CURLOPT_FRESH_CONNECT },
			{ "CURLOPT_FTPAPPEND", 17, CURLOPT_FTPAPPEND },
			{ "CURLOPT_FTPLISTONLY", 19, CURLOPT_FTPLISTONLY },
			{ "CURLOPT_FTPPORT", 15, CURLOPT_FTPPORT },
			{ "CURLOPT_FTPSSLAUTH", 18, CURLOPT_FTPSSLAUTH },
			{ "CURLOPT_FTP_ACCOUNT", 19, CURLOPT_FTP_ACCOUNT },
			{ "CURLOPT_FTP_ALTERNATIVE_TO_USER", 31, CURLOPT_FTP_ALTERNATIVE_TO_USER },
			{ "CURLOPT_FTP_CREATE_MISSING_DIRS", 31, CURLOPT_FTP_CREATE_MISSING_DIRS },
			{ "CURLOPT_FTP_FILEMETHOD", 22, CURLOPT_FTP_FILEMETHOD },
			{ "CURLOPT_FTP_RESPONSE_TIMEOUT", 28, CURLOPT_FTP_RESPONSE_TIMEOUT },
			{ "CURLOPT_FTP_SKIP_PASV_IP", 24, CURLOPT_FTP_SKIP_PASV_IP },
			{ "CURLOPT_FTP_SSL", 15, CURLOPT_FTP_SSL },
			{ "CURLOPT_FTP_SSL_CCC", 19, CURLOPT_FTP_SSL_CCC },
			{ "CURLOPT_FTP_USE_EPRT", 20, CURLOPT_FTP_USE_EPRT },
			{ "CURLOPT_FTP_USE_EPSV", 20, CURLOPT_FTP_USE_EPSV },
			{ "CURLOPT_FTP_USE_PRET", 20, CURLOPT_FTP_USE_PRET },
			{ "CURLOPT_GSSAPI_DELEGATION", 25, CURLOPT_GSSAPI_DELEGATION },
			{ "CURLOPT_HAPPY_EYEBALLS_TIMEOUT_MS", 33, CURLOPT_HAPPY_EYEBALLS_TIMEOUT_MS },
			{ "CURLOPT_HAPROXYPROTOCOL", 23, CURLOPT_HAPROXYPROTOCOL },
			{ "CURLOPT_HAPROXY_CLIENT_IP", 25, CURLOPT_HAPROXY_CLIENT_IP },
			{ "CURLOPT_HEADER", 14, CURLOPT_HEADER },
			{ "CURLOPT_HEADERDATA", 18, CURLOPT_HEADERDATA },
			{ "CURLOPT_HEADERFUNCTION", 22, CURLOPT_HEADERFUNCTION },
			{ "CURLOPT_HEADEROPT", 17, CURLOPT_HEADEROPT },
			{ "CURLOPT_HSTS", 12, CURLOPT_HSTS },
			{ "CURLOPT_HSTSREADDATA", 20, CURLOPT_HSTSREADDATA },
			{ "CURLOPT_HSTSREADFUNCTION", 24, CURLOPT_HSTSREADFUNCTION },
			{ "CURLOPT_HSTSWRITEDATA", 21, CURLOPT_HSTSWRITEDATA },
			{ "CURLOPT_HSTSWRITEFUNCTION", 25, CURLOPT_HSTSWRITEFUNCTION },
			{ "CURLOPT_HSTS_CTRL", 17, CURLOPT_HSTS_CTRL },
			{ "CURLOPT_HTTP09_ALLOWED", 22, CURLOPT_HTTP09_ALLOWED },
			{ "CURLOPT_HTTP200ALIASES", 22, CURLOPT_HTTP200ALIASES },
			{ "CURLOPT_HTTPAUTH", 16, CURLOPT_HTTPAUTH },
			{ "CURLOPT_HTTPGET", 15, CURLOPT_HTTPGET },
			{ "CURLOPT_HTTPHEADER", 18, CURLOPT_HTTPHEADER },
			{ "CURLOPT_HTTPPOST", 16, CURLOPT_HTTPPOST },
			{ "CURLOPT_HTTPPROXYTUNNEL", 23, CURLOPT_HTTPPROXYTUNNEL },
			{ "CURLOPT_HTTP_CONTENT_DECODING", 29, CURLOPT_HTTP_CONTENT_DECODING },
			{ "CURLOPT_HTTP_TRANSFER_DECODING", 30, CURLOPT_HTTP_TRANSFER_DECODING },
			{ "CURLOPT_HTTP_VERSION", 20, CURLOPT_HTTP_VERSION },
			{ "CURLOPT_IGNORE_CONTENT_LENGTH", 29, CURLOPT_IGNORE_CONTENT_LENGTH },
			{ "CURLOPT_INFILE", 14, CURLOPT_INFILE },
			{ "CURLOPT_INFILESIZE", 18, CURLOPT_INFILESIZE },
			{ "CURLOPT_INFILESIZE_LARGE", 24, CURLOPT_INFILESIZE_LARGE },
			{ "CURLOPT_INTERFACE", 17, CURLOPT_INTERFACE },
			{ "CURLOPT_INTERLEAVEDATA", 22, CURLOPT_INTERLEAVEDATA },
			{ "CURLOPT_INTERLEAVEFUNCTION", 26, CURLOPT_INTERLEAVEFUNCTION },
			{ "CURLOPT_IOCTLDATA", 17, CURLOPT_IOCTLDATA },
			{ "CURLOPT_IOCTLFUNCTION", 21, CURLOPT_IOCTLFUNCTION },
			{ "CURLOPT_IPRESOLVE", 17, CURLOPT_IPRESOLVE },
			{ "CURLOPT_ISSUERCERT", 18, CURLOPT_ISSUERCERT },
			{ "CURLOPT_ISSUERCERT_BLOB", 23, CURLOPT_ISSUERCERT_BLOB },
			{ "CURLOPT_KEEP_SENDING_ON_ERROR", 29, CURLOPT_KEEP_SENDING_ON_ERROR },
			{ "CURLOPT_KEYPASSWD", 17, CURLOPT_KEYPASSWD },
			{ "CURLOPT_KRB4LEVEL", 17, CURLOPT_KRB4LEVEL },
			{ "CURLOPT_KRBLEVEL", 16, CURLOPT_KRBLEVEL },
			{ "CURLOPT_LOCALPORT", 17, CURLOPT_LOCALPORT },
			{ "CURLOPT_LOCALPORTRANGE", 22, CURLOPT_LOCALPORTRANGE },
			{ "CURLOPT_LOGIN_OPTIONS", 21, CURLOPT_LOGIN_OPTIONS },
			{ "CURLOPT_LOW_SPEED_LIMIT", 23, CURLOPT_LOW_SPEED_LIMIT },
			{ "CURLOPT_LOW_SPEED_TIME", 22, CURLOPT_LOW_SPEED_TIME },
			{ "CURLOPT_MAIL_AUTH", 17, CURLOPT_MAIL_AUTH },
			{ "CURLOPT_MAIL_FROM", 17, CURLOPT_MAIL_FROM },
			{ "CURLOPT_MAIL_RCPT", 17, CURLOPT_MAIL_RCPT },
			{ "CURLOPT_MAIL_RCPT_ALLLOWFAILS", 29, CURLOPT_MAIL_RCPT_ALLLOWFAILS },
			{ "CURLOPT_MAIL_RCPT_ALLOWFAILS", 28, CURLOPT_MAIL_RCPT_ALLOWFAILS },
			{ "CURLOPT_MAXAGE_CONN", 19, CURLOPT_MAXAGE_CONN },
			{ "CURLOPT_MAXCONNECTS", 19, CURLOPT_MAXCONNECTS },
			{ "CURLOPT_MAXFILESIZE", 19, CURLOPT_MAXFILESIZE },
			{ "CURLOPT_MAXFILESIZE_LARGE", 25, CURLOPT_MAXFILESIZE_LARGE },
			{ "CURLOPT_MAXLIFETIME_CONN", 24, CURLOPT_MAXLIFETIME_CONN },
			{ "CURLOPT_MAXREDIRS", 17, CURLOPT_MAXREDIRS },
			{ "CURLOPT_MAX_RECV_SPEED_LARGE", 28, CURLOPT_MAX_RECV_SPEED_LARGE },
			{ "CURLOPT_MAX_SEND_SPEED_LARGE", 28, CURLOPT_MAX_SEND_SPEED_LARGE },
			{ "CURLOPT_MIMEPOST", 16, CURLOPT_MIMEPOST },
			{ "CURLOPT_MIME_OPTIONS", 20, CURLOPT_MIME_OPTIONS },
			{ "CURLOPT_NETRC", 13, CURLOPT_NETRC },
			{ "CURLOPT_NETRC_FILE", 18, CURLOPT_NETRC_FILE },
			{ "CURLOPT_NEW_DIRECTORY_PERMS", 27, CURLOPT_NEW_DIRECTORY_PERMS },
			{ "CURLOPT_NEW_FILE_PERMS", 22, CURLOPT_NEW_FILE_PERMS },
			{ "CURLOPT_NOBODY", 14, CURLOPT_NOBODY },
			{ "CURLOPT_NOPROGRESS", 18, CURLOPT_NOPROGRESS },
			{ "CURLOPT_NOPROXY", 15, CURLOPT_NOPROXY },
			{ "CURLOPT_NOSIGNAL", 16, CURLOPT_NOSIGNAL },
			{ "CURLOPT_OPENSOCKETDATA", 22, CURLOPT_OPENSOCKETDATA },
			{ "CURLOPT_OPENSOCKETFUNCTION", 26, CURLOPT_OPENSOCKETFUNCTION },
			{ "CURLOPT_PASSWORD", 16, CURLOPT_PASSWORD },
			{ "CURLOPT_PATH_AS_IS", 18, CURLOPT_PATH_AS_IS },
			{ "CURLOPT_PINNEDPUBLICKEY", 23, CURLOPT_PINNEDPUBLICKEY },
			{ "CURLOPT_PIPEWAIT", 16, CURLOPT_PIPEWAIT },
			{ "CURLOPT_PORT", 12, CURLOPT_PORT },
			{ "CURLOPT_POST", 12, CURLOPT_POST },
			{ "CURLOPT_POST301", 15, CURLOPT_POST301 },
			{ "CURLOPT_POSTFIELDS", 18, CURLOPT_POSTFIELDS },
			{ "CURLOPT_POSTFIELDSIZE", 21, CURLOPT_POSTFIELDSIZE },
			{ "CURLOPT_POSTFIELDSIZE_LARGE", 27, CURLOPT_POSTFIELDSIZE_LARGE },
			{ "CURLOPT_POSTQUOTE", 17, CURLOPT_POSTQUOTE },
			{ "CURLOPT_POSTREDIR", 17, CURLOPT_POSTREDIR },
			{ "CURLOPT_PREQUOTE", 16, CURLOPT_PREQUOTE },
			{ "CURLOPT_PREREQDATA", 18, CURLOPT_PREREQDATA },
			{ "CURLOPT_PREREQFUNCTION", 22, CURLOPT_PREREQFUNCTION },
			{ "CURLOPT_PRE_PROXY", 17, CURLOPT_PRE_PROXY },
			{ "CURLOPT_PRIVATE", 15, CURLOPT_PRIVATE },
			{ "CURLOPT_PROGRESSDATA", 20, CURLOPT_PROGRESSDATA },
			{ "CURLOPT_PROGRESSFUNCTION", 24, CURLOPT_PROGRESSFUNCTION },
			{ "CURLOPT_PROTOCOLS", 17, CURLOPT_PROTOCOLS },
			{ "CURLOPT_PROTOCOLS_STR", 21, CURLOPT_PROTOCOLS_STR },
			{ "CURLOPT_PROXY", 13, CURLOPT_PROXY },
			{ "CURLOPT_PROXYAUTH", 17, CURLOPT_PROXYAUTH },
			{ "CURLOPT_PROXYHEADER", 19, CURLOPT_PROXYHEADER },
			{ "CURLOPT_PROXYPASSWORD", 21, CURLOPT_PROXYPASSWORD },
			{ "CURLOPT_PROXYPORT", 17, CURLOPT_PROXYPORT },
			{ "CURLOPT_PROXYTYPE", 17, CURLOPT_PROXYTYPE },
			{ "CURLOPT_PROXYUSERNAME", 21, CURLOPT_PROXYUSERNAME },
			{ "CURLOPT_PROXYUSERPWD", 20, CURLOPT_PROXYUSERPWD },
			{ "CURLOPT_PROXY_CAINFO", 20, CURLOPT_PROXY_CAINFO },
			{ "CURLOPT_PROXY_CAINFO_BLOB", 25, CURLOPT_PROXY_CAINFO_BLOB },
			{ "CURLOPT_PROXY_CAPATH", 20, CURLOPT_PROXY_CAPATH },
			{ "CURLOPT_PROXY_CRLFILE", 21, CURLOPT_PROXY_CRLFILE },
			{ "CURLOPT_PROXY_ISSUERCERT", 24, CURLOPT_PROXY_ISSUERCERT },
			{ "CURLOPT_PROXY_ISSUERCERT_BLOB", 29, CURLOPT_PROXY_ISSUERCERT_BLOB },
			{ "CURLOPT_PROXY_KEYPASSWD", 23, CURLOPT_PROXY_KEYPASSWD },
			{ "CURLOPT_PROXY_PINNEDPUBLICKEY", 29, CURLOPT_PROXY_PINNEDPUBLICKEY },
			{ "CURLOPT_PROXY_SERVICE_NAME", 26, CURLOPT_PROXY_SERVICE_NAME },
			{ "CURLOPT_PROXY_SSLCERT", 21, CURLOPT_PROXY_SSLCERT },
			{ "CURLOPT_PROXY_SSLCERTTYPE", 25, CURLOPT_PROXY_SSLCERTTYPE },
			{ "CURLOPT_PROXY_SSLCERT_BLOB", 26, CURLOPT_PROXY_SSLCERT_BLOB },
			{ "CURLOPT_PROXY_SSLKEY", 20, CURLOPT_PROXY_SSLKEY },
			{ "CURLOPT_PROXY_SSLKEYTYPE", 24, CURLOPT_PROXY_SSLKEYTYPE },
			{ "CURLOPT_PROXY_SSLKEY_BLOB", 25, CURLOPT_PROXY_SSLKEY_BLOB },
			{ "CURLOPT_PROXY_SSLVERSION", 24, CURLOPT_PROXY_SSLVERSION },
			{ "CURLOPT_PROXY_SSL_CIPHER_LIST", 29, CURLOPT_PROXY_SSL_CIPHER_LIST },
			{ "CURLOPT_PROXY_SSL_OPTIONS", 25, CURLOPT_PROXY_SSL_OPTIONS },
			{ "CURLOPT_PROXY_SSL_VERIFYHOST", 28, CURLOPT_PROXY_SSL_VERIFYHOST },
			{ "CURLOPT_PROXY_SSL_VERIFYPEER", 28, CURLOPT_PROXY_SSL_VERIFYPEER },
			{ "CURLOPT_PROXY_TLS13_CIPHERS", 27, CURLOPT_PROXY_TLS13_CIPHERS },
			{ "CURLOPT_PROXY_TLSAUTH_PASSWORD", 30, CURLOPT_PROXY_TLSAUTH_PASSWORD },
			{ "CURLOPT_PROXY_TLSAUTH_TYPE", 26, CURLOPT_PROXY_TLSAUTH_TYPE },
			{ "CURLOPT_PROXY_TLSAUTH_USERNAME", 30, CURLOPT_PROXY_TLSAUTH_USERNAME },
			{ "CURLOPT_PROXY_TRANSFER_MODE", 27, CURLOPT_PROXY_TRANSFER_MODE },
			{ "CURLOPT_PUT", 11, CURLOPT_PUT },
			{ "CURLOPT_QUICK_EXIT", 18, CURLOPT_QUICK_EXIT },
			{ "CURLOPT_QUOTE", 13, CURLOPT_QUOTE },
			{ "CURLOPT_RANDOM_FILE", 19, CURLOPT_RANDOM_FILE },
			{ "CURLOPT_RANGE", 13, CURLOPT_RANGE },
			{ "CURLOPT_READDATA", 16, CURLOPT_READDATA },
			{ "CURLOPT_READFUNCTION", 20, CURLOPT_READFUNCTION },
			{ "CURLOPT_REDIR_PROTOCOLS", 23, CURLOPT_REDIR_PROTOCOLS },
			{ "CURLOPT_REDIR_PROTOCOLS_STR", 27, CURLOPT_REDIR_PROTOCOLS_STR },
			{ "CURLOPT_REFERER", 15, CURLOPT_REFERER },
			{ "CURLOPT_REQUEST_TARGET", 22, CURLOPT_REQUEST_TARGET },
			{ "CURLOPT_RESOLVE", 15, CURLOPT_RESOLVE },
			{ "CURLOPT_RESOLVER_START_DATA", 27, CURLOPT_RESOLVER_START_DATA },
			{ "CURLOPT_RESOLVER_START_FUNCTION", 31, CURLOPT_RESOLVER_START_FUNCTION },
			{ "CURLOPT_RESUME_FROM", 19, CURLOPT_RESUME_FROM },
			{ "CURLOPT_RESUME_FROM_LARGE", 25, CURLOPT_RESUME_FROM_LARGE },
			{ "CURLOPT_RTSPHEADER", 18, CURLOPT_RTSPHEADER },
			{ "CURLOPT_RTSP_CLIENT_CSEQ", 24, CURLOPT_RTSP_CLIENT_CSEQ },
			{ "CURLOPT_RTSP_REQUEST", 20, CURLOPT_RTSP_REQUEST },
			{ "CURLOPT_RTSP_SERVER_CSEQ", 24, CURLOPT_RTSP_SERVER_CSEQ },
			{ "CURLOPT_RTSP_SESSION_ID", 23, CURLOPT_RTSP_SESSION_ID },
			{ "CURLOPT_RTSP_STREAM_URI", 23, CURLOPT_RTSP_STREAM_URI },
			{ "CURLOPT_RTSP_TRANSPORT", 22, CURLOPT_RTSP_TRANSPORT },
			{ "CURLOPT_SASL_AUTHZID", 20, CURLOPT_SASL_AUTHZID },
			{ "CURLOPT_SASL_IR", 15, CURLOPT_SASL_IR },
			{ "CURLOPT_SEEKDATA", 16, CURLOPT_SEEKDATA },
			{ "CURLOPT_SEEKFUNCTION", 20, CURLOPT_SEEKFUNCTION },
			{ "CURLOPT_SERVER_RESPONSE_TIMEOUT", 31, CURLOPT_SERVER_RESPONSE_TIMEOUT },
			{ "CURLOPT_SERVER_RESPONSE_TIMEOUT_MS", 34, CURLOPT_SERVER_RESPONSE_TIMEOUT_MS },
			{ "CURLOPT_SERVICE_NAME", 20, CURLOPT_SERVICE_NAME },
			{ "CURLOPT_SHARE", 13, CURLOPT_SHARE },
			{ "CURLOPT_SOCKOPTDATA", 19, CURLOPT_SOCKOPTDATA },
			{ "CURLOPT_SOCKOPTFUNCTION", 23, CURLOPT_SOCKOPTFUNCTION },
			{ "CURLOPT_SOCKS5_AUTH", 19, CURLOPT_SOCKS5_AUTH },
			{ "CURLOPT_SOCKS5_GSSAPI_NEC", 25, CURLOPT_SOCKS5_GSSAPI_NEC },
			{ "CURLOPT_SOCKS5_GSSAPI_SERVICE", 29, CURLOPT_SOCKS5_GSSAPI_SERVICE },
			{ "CURLOPT_SSH_AUTH_TYPES", 22, CURLOPT_SSH_AUTH_TYPES },
			{ "CURLOPT_SSH_COMPRESSION", 23, CURLOPT_SSH_COMPRESSION },
			{ "CURLOPT_SSH_HOSTKEYDATA", 23, CURLOPT_SSH_HOSTKEYDATA },
			{ "CURLOPT_SSH_HOSTKEYFUNCTION", 27, CURLOPT_SSH_HOSTKEYFUNCTION },
			{ "CURLOPT_SSH_HOST_PUBLIC_KEY_MD5", 31, CURLOPT_SSH_HOST_PUBLIC_KEY_MD5 },
			{ "CURLOPT_SSH_HOST_PUBLIC_KEY_SHA256", 34, CURLOPT_SSH_HOST_PUBLIC_KEY_SHA256 },
			{ "CURLOPT_SSH_KEYDATA", 19, CURLOPT_SSH_KEYDATA },
			{ "CURLOPT_SSH_KEYFUNCTION", 23, CURLOPT_SSH_KEYFUNCTION },
			{ "CURLOPT_SSH_KNOWNHOSTS", 22, CURLOPT_SSH_KNOWNHOSTS },
			{ "CURLOPT_SSH_PRIVATE_KEYFILE", 27, CURLOPT_SSH_PRIVATE_KEYFILE },
			{ "CURLOPT_SSH_PUBLIC_KEYFILE", 26, CURLOPT_SSH_PUBLIC_KEYFILE },
			{ "CURLOPT_SSLCERT", 15, CURLOPT_SSLCERT },
			{ "CURLOPT_SSLCERTPASSWD", 21, CURLOPT_SSLCERTPASSWD },
			{ "CURLOPT_SSLCERTTYPE", 19, CURLOPT_SSLCERTTYPE },
			{ "CURLOPT_SSLCERT_BLOB", 20, CURLOPT_SSLCERT_BLOB },
			{ "CURLOPT_SSLENGINE", 17, CURLOPT_SSLENGINE },
			{ "CURLOPT_SSLENGINE_DEFAULT", 25, CURLOPT_SSLENGINE_DEFAULT },
			{ "CURLOPT_SSLKEY", 14, CURLOPT_SSLKEY },
			{ "CURLOPT_SSLKEYPASSWD", 20, CURLOPT_SSLKEYPASSWD },
			{ "CURLOPT_SSLKEYTYPE", 18, CURLOPT_SSLKEYTYPE },
			{ "CURLOPT_SSLKEY_BLOB", 19, CURLOPT_SSLKEY_BLOB },
			{ "CURLOPT_SSLVERSION", 18, CURLOPT_SSLVERSION },
			{ "CURLOPT_SSL_CIPHER_LIST", 23, CURLOPT_SSL_CIPHER_LIST },
			{ "CURLOPT_SSL_CTX_DATA", 20, CURLOPT_SSL_CTX_DATA },
			{ "CURLOPT_SSL_CTX_FUNCTION", 24, CURLOPT_SSL_CTX_FUNCTION },
			{ "CURLOPT_SSL_EC_CURVES", 21, CURLOPT_SSL_EC_CURVES },
			{ "CURLOPT_SSL_ENABLE_ALPN", 23, CURLOPT_SSL_ENABLE_ALPN },
			{ "CURLOPT_SSL_ENABLE_NPN", 22, CURLOPT_SSL_ENABLE_NPN },
			{ "CURLOPT_SSL_FALSESTART", 22, CURLOPT_SSL_FALSESTART },
			{ "CURLOPT_SSL_OPTIONS", 19, CURLOPT_SSL_OPTIONS },
			{ "CURLOPT_SSL_SESSIONID_CACHE", 27, CURLOPT_SSL_SESSIONID_CACHE },
			{ "CURLOPT_SSL_VERIFYHOST", 22, CURLOPT_SSL_VERIFYHOST },
			{ "CURLOPT_SSL_VERIFYPEER", 22, CURLOPT_SSL_VERIFYPEER },
			{ "CURLOPT_SSL_VERIFYSTATUS", 24, CURLOPT_SSL_VERIFYSTATUS },
			{ "CURLOPT_STDERR", 14, CURLOPT_STDERR },
			{ "CURLOPT_STREAM_DEPENDS", 22, CURLOPT_STREAM_DEPENDS },
			{ "CURLOPT_STREAM_DEPENDS_E", 24, CURLOPT_STREAM_DEPENDS_E },
			{ "CURLOPT_STREAM_WEIGHT", 21, CURLOPT_STREAM_WEIGHT },
			{ "CURLOPT_SUPPRESS_CONNECT_HEADERS", 32, CURLOPT_SUPPRESS_CONNECT_HEADERS },
			{ "CURLOPT_TCP_FASTOPEN", 20, CURLOPT_TCP_FASTOPEN },
			{ "CURLOPT_TCP_KEEPALIVE", 21, CURLOPT_TCP_KEEPALIVE },
			{ "CURLOPT_TCP_KEEPCNT", 19, CURLOPT_TCP_KEEPCNT },
			{ "CURLOPT_TCP_KEEPIDLE", 20, CURLOPT_TCP_KEEPIDLE },
			{ "CURLOPT_TCP_KEEPINTVL", 21, CURLOPT_TCP_KEEPINTVL },
			{ "CURLOPT_TCP_NODELAY", 19, CURLOPT_TCP_NODELAY },
			{ "CURLOPT_TELNETOPTIONS", 21, CURLOPT_TELNETOPTIONS },
			{ "CURLOPT_TFTP_BLKSIZE", 20, CURLOPT_TFTP_BLKSIZE },
			{ "CURLOPT_TFTP_NO_OPTIONS", 23, CURLOPT_TFTP_NO_OPTIONS },
			{ "CURLOPT_TIMECONDITION", 21, CURLOPT_TIMECONDITION },
			{ "CURLOPT_TIMEOUT", 15, CURLOPT_TIMEOUT },
			{ "CURLOPT_TIMEOUT_MS", 18, CURLOPT_TIMEOUT_MS },
			{ "CURLOPT_TIMEVALUE", 17, CURLOPT_TIMEVALUE },
			{ "CURLOPT_TIMEVALUE_LARGE", 23, CURLOPT_TIMEVALUE_LARGE },
			{ "CURLOPT_TLS13_CIPHERS", 21, CURLOPT_TLS13_CIPHERS },
			{ "CURLOPT_TLSAUTH_PASSWORD", 24, CURLOPT_TLSAUTH_PASSWORD },
			{ "CURLOPT_TLSAUTH_TYPE", 20, CURLOPT_TLSAUTH_TYPE },
			{ "CURLOPT_TLSAUTH_USERNAME", 24, CURLOPT_TLSAUTH_USERNAME },
			{ "CURLOPT_TRAILERDATA", 19, CURLOPT_TRAILERDATA },
			{ "CURLOPT_TRAILERFUNCTION", 23, CURLOPT_TRAILERFUNCTION },
			{ "CURLOPT_TRANSFERTEXT", 20, CURLOPT_TRANSFERTEXT },
			{ "CURLOPT_TRANSFER_ENCODING", 25, CURLOPT_TRANSFER_ENCODING },
			{ "CURLOPT_UNIX_SOCKET_PATH", 24, CURLOPT_UNIX_SOCKET_PATH },
			{ "CURLOPT_UNRESTRICTED_AUTH", 25, CURLOPT_UNRESTRICTED_AUTH },
			{ "CURLOPT_UPKEEP_INTERVAL_MS", 26, CURLOPT_UPKEEP_INTERVAL_MS },
			{ "CURLOPT_UPLOAD", 14, CURLOPT_UPLOAD },
			{ "CURLOPT_UPLOAD_BUFFERSIZE", 25, CURLOPT_UPLOAD_BUFFERSIZE },
			{ "CURLOPT_URL", 11, CURLOPT_URL },
			{ "CURLOPT_USERAGENT", 17, CURLOPT_USERAGENT },
			{ "CURLOPT_USERNAME", 16, CURLOPT_USERNAME },
			{ "CURLOPT_USERPWD", 15, CURLOPT_USERPWD },
			{ "CURLOPT_USE_SSL", 15, CURLOPT_USE_SSL },
			{ "CURLOPT_VERBOSE", 15, CURLOPT_VERBOSE },
			{ "CURLOPT_WILDCARDMATCH", 21, CURLOPT_WILDCARDMATCH },
			{ "CURLOPT_WRITEDATA", 17, CURLOPT_WRITEDATA },
			{ "CURLOPT_WRITEFUNCTION", 21, CURLOPT_WRITEFUNCTION },
			{ "CURLOPT_WRITEHEADER", 19, CURLOPT_WRITEHEADER },
			{ "CURLOPT_WRITEINFO", 17, CURLOPT_WRITEINFO },
			{ "CURLOPT_WS_OPTIONS", 18, CURLOPT_WS_OPTIONS },
			{ "CURLOPT_XFERINFODATA", 20, CURLOPT_XFERINFODATA },
			{ "CURLOPT_XFERINFOFUNCTION", 24, CURLOPT_XFERINFOFUNCTION },
			{ "CURLOPT_XOAUTH2_BEARER", 22, CURLOPT_XOAUTH2_BEARER },
			{ "CURLOT_BLOB", 11, CURLOT_BLOB },
			{ "CURLOT_CBPTR", 12, CURLOT_CBPTR },
			{ "CURLOT_FUNCTION", 15, CURLOT_FUNCTION },
			{ "CURLOT_LONG", 11, CURLOT_LONG },
			{ "CURLOT_OBJECT", 13, CURLOT_OBJECT },
			{ "CURLOT_OFF_T", 12, CURLOT_OFF_T },
			{ "CURLOT_SLIST", 12, CURLOT_SLIST },
			{ "CURLOT_STRING", 13, CURLOT_STRING },
			{ "CURLOT_VALUES", 13, CURLOT_VALUES },
			{ "CURLPAUSE_ALL", 13, CURLPAUSE_ALL },
			{ "CURLPAUSE_CONT", 14, CURLPAUSE_CONT },
			{ "CURLPAUSE_RECV", 14, CURLPAUSE_RECV },
			{ "CURLPAUSE_RECV_CONT", 19, CURLPAUSE_RECV_CONT },
			{ "CURLPAUSE_SEND", 14, CURLPAUSE_SEND },
			{ "CURLPAUSE_SEND_CONT", 19, CURLPAUSE_SEND_CONT },
			{ "CURLPIPE_HTTP1", 14, CURLPIPE_HTTP1 },
			{ "CURLPIPE_MULTIPLEX", 18, CURLPIPE_MULTIPLEX },
			{ "CURLPIPE_NOTHING", 16, CURLPIPE_NOTHING },
			{ "CURLPROTO_ALL", 13, CURLPROTO_ALL },
			{ "CURLPROTO_DICT", 14, CURLPROTO_DICT },
			{ "CURLPROTO_FILE", 14, CURLPROTO_FILE },
			{ "CURLPROTO_FTP", 13, CURLPROTO_FTP },
			{ "CURLPROTO_FTPS", 14, CURLPROTO_FTPS },
			{ "CURLPROTO_GOPHER", 16, CURLPROTO_GOPHER },
			{ "CURLPROTO_GOPHERS", 17, CURLPROTO_GOPHERS },
			{ "CURLPROTO_HTTP", 14, CURLPROTO_HTTP },
			{ "CURLPROTO_HTTPS", 15, CURLPROTO_HTTPS },
			{ "CURLPROTO_IMAP", 14, CURLPROTO_IMAP },
			{ "CURLPROTO_IMAPS", 15, CURLPROTO_IMAPS },
			{ "CURLPROTO_LDAP", 14, CURLPROTO_LDAP },
			{ "CURLPROTO_LDAPS", 15, CURLPROTO_LDAPS },
			{ "CURLPROTO_MQTT", 14, CURLPROTO_MQTT },
			{ "CURLPROTO_POP3", 14, CURLPROTO_POP3 },
			{ "CURLPROTO_POP3S", 15, CURLPROTO_POP3S },
			{ "CURLPROTO_RTMP", 14, CURLPROTO_RTMP },
			{ "CURLPROTO_RTMPE", 15, CURLPROTO_RTMPE },
			{ "CURLPROTO_RTMPS", 15, CURLPROTO_RTMPS },
			{ "CURLPROTO_RTMPT", 15, CURLPROTO_RTMPT },
			{ "CURLPROTO_RTMPTE", 16, CURLPROTO_RTMPTE },
			{ "CURLPROTO_RTMPTS", 16, CURLPROTO_RTMPTS },
			{ "CURLPROTO_RTSP", 14, CURLPROTO_RTSP },
			{ "CURLPROTO_SCP", 13, CURLPROTO_SCP },
			{ "CURLPROTO_SFTP", 14, CURLPROTO_SFTP },
			{ "CURLPROTO_SMB", 13, CURLPROTO_SMB },
			{ "CURLPROTO_SMBS", 14, CURLPROTO_SMBS },
			{ "CURLPROTO_SMTP", 14, CURLPROTO_SMTP },
			{ "CURLPROTO_SMTPS", 15, CURLPROTO_SMTPS },
			{ "CURLPROTO_TELNET", 16, CURLPROTO_TELNET },
			{ "CURLPROTO_TFTP", 14, CURLPROTO_TFTP },
			{ "CURLPROXY_HTTP", 14, CURLPROXY_HTTP },
			{ "CURLPROXY_HTTPS", 15, CURLPROXY_HTTPS },
			{ "CURLPROXY_HTTPS2", 16, CURLPROXY_HTTPS2 },
			{ "CURLPROXY_HTTP_1_0", 18, CURLPROXY_HTTP_1_0 },
			{ "CURLPROXY_SOCKS4", 16, CURLPROXY_SOCKS4 },
			{ "CURLPROXY_SOCKS4A", 17, CURLPROXY_SOCKS4A },
			{ "CURLPROXY_SOCKS5", 16, CURLPROXY_SOCKS5 },
			{ "CURLPROXY_SOCKS5_HOSTNAME", 25, CURLPROXY_SOCKS5_HOSTNAME },
			{ "CURLPX_BAD_ADDRESS_TYPE", 23, CURLPX_BAD_ADDRESS_TYPE },
			{ "CURLPX_BAD_VERSION", 18, CURLPX_BAD_VERSION },
			{ "CURLPX_CLOSED", 13, CURLPX_CLOSED },
			{ "CURLPX_GSSAPI", 13, CURLPX_GSSAPI },
			{ "CURLPX_GSSAPI_PERMSG", 20, CURLPX_GSSAPI_PERMSG },
			{ "CURLPX_GSSAPI_PROTECTION", 24, CURLPX_GSSAPI_PROTECTION },
			{ "CURLPX_IDENTD", 13, CURLPX_IDENTD },
			{ "CURLPX_IDENTD_DIFFER", 20, CURLPX_IDENTD_DIFFER },
			{ "CURLPX_LONG_HOSTNAME", 20, CURLPX_LONG_HOSTNAME },
			{ "CURLPX_LONG_PASSWD", 18, CURLPX_LONG_PASSWD },
			{ "CURLPX_LONG_USER", 16, CURLPX_LONG_USER },
			{ "CURLPX_NO_AUTH", 14, CURLPX_NO_AUTH },
			{ "CURLPX_OK", 9, CURLPX_OK },
			{ "CURLPX_RECV_ADDRESS", 19, CURLPX_RECV_ADDRESS },
			{ "CURLPX_RECV_AUTH", 16, CURLPX_RECV_AUTH },
			{ "CURLPX_RECV_CONNECT", 19, CURLPX_RECV_CONNECT },
			{ "CURLPX_RECV_REQACK", 18, CURLPX_RECV_REQACK },
			{ "CURLPX_REPLY_ADDRESS_TYPE_NOT_SUPPORTED", 39, CURLPX_REPLY_ADDRESS_TYPE_NOT_SUPPORTED },
			{ "CURLPX_REPLY_COMMAND_NOT_SUPPORTED", 34, CURLPX_REPLY_COMMAND_NOT_SUPPORTED },
			{ "CURLPX_REPLY_CONNECTION_REFUSED", 31, CURLPX_REPLY_CONNECTION_REFUSED },
			{ "CURLPX_REPLY_GENERAL_SERVER_FAILURE", 35, CURLPX_REPLY_GENERAL_SERVER_FAILURE },
			{ "CURLPX_REPLY_HOST_UNREACHABLE", 29, CURLPX_REPLY_HOST_UNREACHABLE },
			{ "CURLPX_REPLY_NETWORK_UNREACHABLE", 32, CURLPX_REPLY_NETWORK_UNREACHABLE },
			{ "CURLPX_REPLY_NOT_ALLOWED", 24, CURLPX_REPLY_NOT_ALLOWED },
			{ "CURLPX_REPLY_TTL_EXPIRED", 24, CURLPX_REPLY_TTL_EXPIRED },
			{ "CURLPX_REPLY_UNASSIGNED", 23, CURLPX_REPLY_UNASSIGNED },
			{ "CURLPX_REQUEST_FAILED", 21, CURLPX_REQUEST_FAILED },
			{ "CURLPX_RESOLVE_HOST", 19, CURLPX_RESOLVE_HOST },
			{ "CURLPX_SEND_AUTH", 16, CURLPX_SEND_AUTH },
			{ "CURLPX_SEND_CONNECT", 19, CURLPX_SEND_CONNECT },
			{ "CURLPX_SEND_REQUEST", 19, CURLPX_SEND_REQUEST },
			{ "CURLPX_UNKNOWN_FAIL", 19, CURLPX_UNKNOWN_FAIL },
			{ "CURLPX_UNKNOWN_MODE", 19, CURLPX_UNKNOWN_MODE },
			{ "CURLPX_USER_REJECTED", 20, CURLPX_USER_REJECTED },
			{ "CURLSHE_BAD_OPTION", 18, CURLSHE_BAD_OPTION },
			{ "CURLSHE_INVALID", 15, CURLSHE_INVALID },
			{ "CURLSHE_IN_USE", 14, CURLSHE_IN_USE },
			{ "CURLSHE_NOMEM", 13, CURLSHE_NOMEM },
			{ "CURLSHE_NOT_BUILT_IN", 20, CURLSHE_NOT_BUILT_IN },
			{ "CURLSHE_OK", 10, CURLSHE_OK },
			{ "CURLSOCKTYPE_ACCEPT", 19, CURLSOCKTYPE_ACCEPT },
			{ "CURLSOCKTYPE_IPCXN", 18, CURLSOCKTYPE_IPCXN },
			{ "CURLSSH_AUTH_AGENT", 18, CURLSSH_AUTH_AGENT },
			{ "CURLSSH_AUTH_ANY", 16, CURLSSH_AUTH_ANY },
			{ "CURLSSH_AUTH_DEFAULT", 20, CURLSSH_AUTH_DEFAULT },
			{ "CURLSSH_AUTH_GSSAPI", 19, CURLSSH_AUTH_GSSAPI },
			{ "CURLSSH_AUTH_HOST", 17, CURLSSH_AUTH_HOST },
			{ "CURLSSH_AUTH_KEYBOARD", 21, CURLSSH_AUTH_KEYBOARD },
			{ "CURLSSH_AUTH_NONE", 17, CURLSSH_AUTH_NONE },
			{ "CURLSSH_AUTH_PASSWORD", 21, CURLSSH_AUTH_PASSWORD },
			{ "CURLSSH_AUTH_PUBLICKEY", 22, CURLSSH_AUTH_PUBLICKEY },
			{ "CURLSSLBACKEND_AWSLC", 20, CURLSSLBACKEND_AWSLC },
			{ "CURLSSLBACKEND_AXTLS", 20, CURLSSLBACKEND_AXTLS },
			{ "CURLSSLBACKEND_BEARSSL", 22, CURLSSLBACKEND_BEARSSL },
			{ "CURLSSLBACKEND_BORINGSSL", 24, CURLSSLBACKEND_BORINGSSL },
			{ "CURLSSLBACKEND_CYASSL", 21, CURLSSLBACKEND_CYASSL },
			{ "CURLSSLBACKEND_DARWINSSL", 24, CURLSSLBACKEND_DARWINSSL },
			{ "CURLSSLBACKEND_GNUTLS", 21, CURLSSLBACKEND_GNUTLS },
			{ "CURLSSLBACKEND_GSKIT", 20, CURLSSLBACKEND_GSKIT },
			{ "CURLSSLBACKEND_LIBRESSL", 23, CURLSSLBACKEND_LIBRESSL },
			{ "CURLSSLBACKEND_MBEDTLS", 22, CURLSSLBACKEND_MBEDTLS },
			{ "CURLSSLBACKEND_MESALINK", 23, CURLSSLBACKEND_MESALINK },
			{ "CURLSSLBACKEND_NONE", 19, CURLSSLBACKEND_NONE },
			{ "CURLSSLBACKEND_NSS", 18, CURLSSLBACKEND_NSS },
			{ "CURLSSLBACKEND_OPENSSL", 22, CURLSSLBACKEND_OPENSSL },
			{ "CURLSSLBACKEND_POLARSSL", 23, CURLSSLBACKEND_POLARSSL },
			{ "CURLSSLBACKEND_RUSTLS", 21, CURLSSLBACKEND_RUSTLS },
			{ "CURLSSLBACKEND_SCHANNEL", 23, CURLSSLBACKEND_SCHANNEL },
			{ "CURLSSLBACKEND_SECURETRANSPORT", 30, CURLSSLBACKEND_SECURETRANSPORT },
			{ "CURLSSLBACKEND_WOLFSSL", 22, CURLSSLBACKEND_WOLFSSL },
			{ "CURLSSLOPT_ALLOW_BEAST", 22, CURLSSLOPT_ALLOW_BEAST },
			{ "CURLSSLOPT_AUTO_CLIENT_CERT", 27, CURLSSLOPT_AUTO_CLIENT_CERT },
			{ "CURLSSLOPT_EARLYDATA", 20, CURLSSLOPT_EARLYDATA },
			{ "CURLSSLOPT_NATIVE_CA", 20, CURLSSLOPT_NATIVE_CA },
			{ "CURLSSLOPT_NO_PARTIALCHAIN", 26, CURLSSLOPT_NO_PARTIALCHAIN },
			{ "CURLSSLOPT_NO_REVOKE", 20, CURLSSLOPT_NO_REVOKE },
			{ "CURLSSLOPT_REVOKE_BEST_EFFORT", 29, CURLSSLOPT_REVOKE_BEST_EFFORT },
			{ "CURLSSLSET_NO_BACKENDS", 22, CURLSSLSET_NO_BACKENDS },
			{ "CURLSSLSET_OK", 13, CURLSSLSET_OK },
			{ "CURLSSLSET_TOO_LATE", 19, CURLSSLSET_TOO_LATE },
			{ "CURLSSLSET_UNKNOWN_BACKEND", 26, CURLSSLSET_UNKNOWN_BACKEND },
			{ "CURLSTS_DONE", 12, CURLSTS_DONE },
			{ "CURLSTS_FAIL", 12, CURLSTS_FAIL },
			{ "CURLSTS_OK", 10, CURLSTS_OK },
			{ "CURLUE_BAD_FILE_URL", 19, CURLUE_BAD_FILE_URL },
			{ "CURLUE_BAD_FRAGMENT", 19, CURLUE_BAD_FRAGMENT },
			{ "CURLUE_BAD_HANDLE", 17, CURLUE_BAD_HANDLE },
			{ "CURLUE_BAD_HOSTNAME", 19, CURLUE_BAD_HOSTNAME },
			{ "CURLUE_BAD_IPV6", 15, CURLUE_BAD_IPV6 },
			{ "CURLUE_BAD_LOGIN", 16, CURLUE_BAD_LOGIN },
			{ "CURLUE_BAD_PARTPOINTER", 22, CURLUE_BAD_PARTPOINTER },
			{ "CURLUE_BAD_PASSWORD", 19, CURLUE_BAD_PASSWORD },
			{ "CURLUE_BAD_PATH", 15, CURLUE_BAD_PATH },
			{ "CURLUE_BAD_PORT_NUMBER", 22, CURLUE_BAD_PORT_NUMBER },
			{ "CURLUE_BAD_QUERY", 16, CURLUE_BAD_QUERY },
			{ "CURLUE_BAD_SCHEME", 17, CURLUE_BAD_SCHEME },
			{ "CURLUE_BAD_SLASHES", 18, CURLUE_BAD_SLASHES },
			{ "CURLUE_BAD_USER", 15, CURLUE_BAD_USER },
			{ "CURLUE_LACKS_IDN", 16, CURLUE_LACKS_IDN },
			{ "CURLUE_MALFORMED_INPUT", 22, CURLUE_MALFORMED_INPUT },
			{ "CURLUE_NO_FRAGMENT", 18, CURLUE_NO_FRAGMENT },
			{ "CURLUE_NO_HOST", 14, CURLUE_NO_HOST },
			{ "CURLUE_NO_OPTIONS", 17, CURLUE_NO_OPTIONS },
			{ "CURLUE_NO_PASSWORD", 18, CURLUE_NO_PASSWORD },
			{ "CURLUE_NO_PORT", 14, CURLUE_NO_PORT },
			{ "CURLUE_NO_QUERY", 15, CURLUE_NO_QUERY },
			{ "CURLUE_NO_SCHEME", 16, CURLUE_NO_SCHEME },
			{ "CURLUE_NO_USER", 14, CURLUE_NO_USER },
			{ "CURLUE_NO_ZONEID", 16, CURLUE_NO_ZONEID },
			{ "CURLUE_OK", 9, CURLUE_OK },
			{ "CURLUE_OUT_OF_MEMORY", 20, CURLUE_OUT_OF_MEMORY },
			{ "CURLUE_TOO_LARGE", 16, CURLUE_TOO_LARGE },
			{ "CURLUE_UNKNOWN_PART", 19, CURLUE_UNKNOWN_PART },
			{ "CURLUE_UNSUPPORTED_SCHEME", 25, CURLUE_UNSUPPORTED_SCHEME },
			{ "CURLUE_URLDECODE", 16, CURLUE_URLDECODE },
			{ "CURLUE_USER_NOT_ALLOWED", 23, CURLUE_USER_NOT_ALLOWED },
			{ "CURLUPART_FRAGMENT", 18, CURLUPART_FRAGMENT },
			{ "CURLUPART_HOST", 14, CURLUPART_HOST },
			{ "CURLUPART_OPTIONS", 17, CURLUPART_OPTIONS },
			{ "CURLUPART_PASSWORD", 18, CURLUPART_PASSWORD },
			{ "CURLUPART_PATH", 14, CURLUPART_PATH },
			{ "CURLUPART_PORT", 14, CURLUPART_PORT },
			{ "CURLUPART_QUERY", 15, CURLUPART_QUERY },
			{ "CURLUPART_SCHEME", 16, CURLUPART_SCHEME },
			{ "CURLUPART_URL", 13, CURLUPART_URL },
			{ "CURLUPART_USER", 14, CURLUPART_USER },
			{ "CURLUPART_ZONEID", 16, CURLUPART_ZONEID },
			{ "CURLUSESSL_ALL", 14, CURLUSESSL_ALL },
			{ "CURLUSESSL_CONTROL", 18, CURLUSESSL_CONTROL },
			{ "CURLUSESSL_NONE", 15, CURLUSESSL_NONE },
			{ "CURLUSESSL_TRY", 14, CURLUSESSL_TRY },
			{ "CURL_CHUNK_BGN_FUNC_FAIL", 24, CURL_CHUNK_BGN_FUNC_FAIL },
			{ "CURL_CHUNK_BGN_FUNC_OK", 22, CURL_CHUNK_BGN_FUNC_OK },
			{ "CURL_CHUNK_BGN_FUNC_SKIP", 24, CURL_CHUNK_BGN_FUNC_SKIP },
			{ "CURL_CHUNK_END_FUNC_FAIL", 24, CURL_CHUNK_END_FUNC_FAIL },
			{ "CURL_CHUNK_END_FUNC_OK", 22, CURL_CHUNK_END_FUNC_OK },
			{ "CURL_ERROR_SIZE", 15, CURL_ERROR_SIZE },
			{ "CURL_FNMATCHFUNC_FAIL", 21, CURL_FNMATCHFUNC_FAIL },
			{ "CURL_FNMATCHFUNC_MATCH", 22, CURL_FNMATCHFUNC_MATCH },
			{ "CURL_FNMATCHFUNC_NOMATCH", 24, CURL_FNMATCHFUNC_NOMATCH },
			{ "CURL_GLOBAL_ACK_EINTR", 21, CURL_GLOBAL_ACK_EINTR },
			{ "CURL_GLOBAL_ALL", 15, CURL_GLOBAL_ALL },
			{ "CURL_GLOBAL_DEFAULT", 19, CURL_GLOBAL_DEFAULT },
			{ "CURL_GLOBAL_NOTHING", 19, CURL_GLOBAL_NOTHING },
			{ "CURL_GLOBAL_SSL", 15, CURL_GLOBAL_SSL },
			{ "CURL_GLOBAL_WIN32", 17, CURL_GLOBAL_WIN32 },
			{ "CURL_HET_DEFAULT", 16, CURL_HET_DEFAULT },
			{ "CURL_HTTPPOST_BUFFER", 20, CURL_HTTPPOST_BUFFER },
			{ "CURL_HTTPPOST_CALLBACK", 22, CURL_HTTPPOST_CALLBACK },
			{ "CURL_HTTPPOST_FILENAME", 22, CURL_HTTPPOST_FILENAME },
			{ "CURL_HTTPPOST_LARGE", 19, CURL_HTTPPOST_LARGE },
			{ "CURL_HTTPPOST_PTRBUFFER", 23, CURL_HTTPPOST_PTRBUFFER },
			{ "CURL_HTTPPOST_PTRCONTENTS", 25, CURL_HTTPPOST_PTRCONTENTS },
			{ "CURL_HTTPPOST_PTRNAME", 21, CURL_HTTPPOST_PTRNAME },
			{ "CURL_HTTPPOST_READFILE", 22, CURL_HTTPPOST_READFILE },
			{ "CURL_HTTP_VERSION_1_0", 21, CURL_HTTP_VERSION_1_0 },
			{ "CURL_HTTP_VERSION_1_1", 21, CURL_HTTP_VERSION_1_1 },
			{ "CURL_HTTP_VERSION_2", 19, CURL_HTTP_VERSION_2 },
			{ "CURL_HTTP_VERSION_2TLS", 22, CURL_HTTP_VERSION_2TLS },
			{ "CURL_HTTP_VERSION_2_0", 21, CURL_HTTP_VERSION_2_0 },
			{ "CURL_HTTP_VERSION_2_PRIOR_KNOWLEDGE", 35, CURL_HTTP_VERSION_2_PRIOR_KNOWLEDGE },
			{ "CURL_HTTP_VERSION_3", 19, CURL_HTTP_VERSION_3 },
			{ "CURL_HTTP_VERSION_3ONLY", 23, CURL_HTTP_VERSION_3ONLY },
			{ "CURL_HTTP_VERSION_NONE", 22, CURL_HTTP_VERSION_NONE },
			{ "CURL_IPRESOLVE_V4", 17, CURL_IPRESOLVE_V4 },
			{ "CURL_IPRESOLVE_V6", 17, CURL_IPRESOLVE_V6 },
			{ "CURL_IPRESOLVE_WHATEVER", 23, CURL_IPRESOLVE_WHATEVER },
			{ "CURL_MAX_HTTP_HEADER", 20, CURL_MAX_HTTP_HEADER },
			{ "CURL_MAX_READ_SIZE", 18, CURL_MAX_READ_SIZE },
			{ "CURL_MAX_WRITE_SIZE", 19, CURL_MAX_WRITE_SIZE },
			{ "CURL_NETRC_IGNORED", 18, CURL_NETRC_IGNORED },
			{ "CURL_NETRC_OPTIONAL", 19, CURL_NETRC_OPTIONAL },
			{ "CURL_NETRC_REQUIRED", 19, CURL_NETRC_REQUIRED },
			{ "CURL_PREREQFUNC_ABORT", 21, CURL_PREREQFUNC_ABORT },
			{ "CURL_PREREQFUNC_OK", 18, CURL_PREREQFUNC_OK },
			{ "CURL_PROGRESSFUNC_CONTINUE", 26, CURL_PROGRESSFUNC_CONTINUE },
			{ "CURL_PUSH_DENY", 14, CURL_PUSH_DENY },
			{ "CURL_PUSH_ERROROUT", 18, CURL_PUSH_ERROROUT },
			{ "CURL_PUSH_OK", 12, CURL_PUSH_OK },
			{ "CURL_READFUNC_ABORT", 19, CURL_READFUNC_ABORT },
			{ "CURL_READFUNC_PAUSE", 19, CURL_READFUNC_PAUSE },
			{ "CURL_REDIR_GET_ALL", 18, CURL_REDIR_GET_ALL },
			{ "CURL_REDIR_POST_301", 19, CURL_REDIR_POST_301 },
			{ "CURL_REDIR_POST_302", 19, CURL_REDIR_POST_302 },
			{ "CURL_REDIR_POST_303", 19, CURL_REDIR_POST_303 },
			{ "CURL_REDIR_POST_ALL", 19, CURL_REDIR_POST_ALL },
			{ "CURL_RTSPREQ_ANNOUNCE", 21, CURL_RTSPREQ_ANNOUNCE },
			{ "CURL_RTSPREQ_DESCRIBE", 21, CURL_RTSPREQ_DESCRIBE },
			{ "CURL_RTSPREQ_GET_PARAMETER", 26, CURL_RTSPREQ_GET_PARAMETER },
			{ "CURL_RTSPREQ_NONE", 17, CURL_RTSPREQ_NONE },
			{ "CURL_RTSPREQ_OPTIONS", 20, CURL_RTSPREQ_OPTIONS },
			{ "CURL_RTSPREQ_PAUSE", 18, CURL_RTSPREQ_PAUSE },
			{ "CURL_RTSPREQ_PLAY", 17, CURL_RTSPREQ_PLAY },
			{ "CURL_RTSPREQ_RECEIVE", 20, CURL_RTSPREQ_RECEIVE },
			{ "CURL_RTSPREQ_RECORD", 19, CURL_RTSPREQ_RECORD },
			{ "CURL_RTSPREQ_SETUP", 18, CURL_RTSPREQ_SETUP },
			{ "CURL_RTSPREQ_SET_PARAMETER", 26, CURL_RTSPREQ_SET_PARAMETER },
			{ "CURL_RTSPREQ_TEARDOWN", 21, CURL_RTSPREQ_TEARDOWN },
			{ "CURL_SEEKFUNC_CANTSEEK", 22, CURL_SEEKFUNC_CANTSEEK },
			{ "CURL_SEEKFUNC_FAIL", 18, CURL_SEEKFUNC_FAIL },
			{ "CURL_SEEKFUNC_OK", 16, CURL_SEEKFUNC_OK },
			{ "CURL_SOCKET_BAD", 15, CURL_SOCKET_BAD },
			{ "CURL_SOCKOPT_ALREADY_CONNECTED", 30, CURL_SOCKOPT_ALREADY_CONNECTED },
			{ "CURL_SOCKOPT_ERROR", 18, CURL_SOCKOPT_ERROR },
			{ "CURL_SOCKOPT_OK", 15, CURL_SOCKOPT_OK },
			{ "CURL_SSLVERSION_DEFAULT", 23, CURL_SSLVERSION_DEFAULT },
			{ "CURL_SSLVERSION_MAX_DEFAULT", 27, CURL_SSLVERSION_MAX_DEFAULT },
			{ "CURL_SSLVERSION_MAX_NONE", 24, CURL_SSLVERSION_MAX_NONE },
			{ "CURL_SSLVERSION_MAX_TLSv1_0", 27, CURL_SSLVERSION_MAX_TLSv1_0 },
			{ "CURL_SSLVERSION_MAX_TLSv1_1", 27, CURL_SSLVERSION_MAX_TLSv1_1 },
			{ "CURL_SSLVERSION_MAX_TLSv1_2", 27, CURL_SSLVERSION_MAX_TLSv1_2 },
			{ "CURL_SSLVERSION_MAX_TLSv1_3", 27, CURL_SSLVERSION_MAX_TLSv1_3 },
			{ "CURL_SSLVERSION_SSLv2", 21, CURL_SSLVERSION_SSLv2 },
			{ "CURL_SSLVERSION_SSLv3", 21, CURL_SSLVERSION_SSLv3 },
			{ "CURL_SSLVERSION_TLSv1", 21, CURL_SSLVERSION_TLSv1 },
			{ "CURL_SSLVERSION_TLSv1_0", 23, CURL_SSLVERSION_TLSv1_0 },
			{ "CURL_SSLVERSION_TLSv1_1", 23, CURL_SSLVERSION_TLSv1_1 },
			{ "CURL_SSLVERSION_TLSv1_2", 23, CURL_SSLVERSION_TLSv1_2 },
			{ "CURL_SSLVERSION_TLSv1_3", 23, CURL_SSLVERSION_TLSv1_3 },
			{ "CURL_TIMECOND_IFMODSINCE", 24, CURL_TIMECOND_IFMODSINCE },
			{ "CURL_TIMECOND_IFUNMODSINCE", 26, CURL_TIMECOND_IFUNMODSINCE },
			{ "CURL_TIMECOND_LASTMOD", 21, CURL_TIMECOND_LASTMOD },
			{ "CURL_TIMECOND_NONE", 18, CURL_TIMECOND_NONE },
			{ "CURL_TLSAUTH_NONE", 17, CURL_TLSAUTH_NONE },
			{ "CURL_TLSAUTH_SRP", 16, CURL_TLSAUTH_SRP },
			{ "CURL_TRAILERFUNC_ABORT", 22, CURL_TRAILERFUNC_ABORT },
			{ "CURL_TRAILERFUNC_OK", 19, CURL_TRAILERFUNC_OK },
			{ "CURL_UPKEEP_INTERVAL_DEFAULT", 28, CURL_UPKEEP_INTERVAL_DEFAULT },
			{ "CURL_WAIT_POLLIN", 16, CURL_WAIT_POLLIN },
			{ "CURL_WAIT_POLLOUT", 17, CURL_WAIT_POLLOUT },
			{ "CURL_WAIT_POLLPRI", 17, CURL_WAIT_POLLPRI },
			{ "CURL_WRITEFUNC_ERROR", 20, CURL_WRITEFUNC_ERROR },
			{ "CURL_WRITEFUNC_PAUSE", 20, CURL_WRITEFUNC_PAUSE },
			{ "CURL_ZERO_TERMINATED", 20, CURL_ZERO_TERMINATED },
			{ NULL, 0, 0 }
		};
		const struct iv_s *value_for_iv = values_for_iv;
		while ( value_for_iv->name ) {
			perl_curl_constant_add(aTHX_ symbol_table, value_for_iv->name,
				value_for_iv->namelen, newSViv( value_for_iv->value ) );
			++value_for_iv;
		}

		++PL_sub_generation;
	}

#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#line 3926 "Curl.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
